/*
 * Project : "MindsEye"
 * Copyright 1996, 1998. All Rights Reserved.
 * Author(s) Frank Meier, M. Kuball
 *
 * $Id: prisma.h,v 1.2 2002/06/17 20:28:25 ainvar Exp $
 *
 *
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 * OVERVIEW
 * ========
 *
 */

#ifndef __PRISMA_H_
#define __PRISMA_H_

#include "3dlib/shape.h"


/**
 */
class G3DPrisma : public G3DShape
{
  DECLARE_DYN

public:
  G3DPrisma ();
  G3DPrisma( const G3DPrisma& );
  virtual ~G3DPrisma();

    ///Return a list with the names and types of the object s parameter.
  virtual const Field* getFieldList ();
    /**Copy pointers to the geometric data to the list. The order is:
       origin, e1, e2, e3*/
  virtual uint   getParameter( Param* );
    ///
  virtual void   resetBoundingBox ();
    ///
  virtual void   shade( int ) const;

protected:
  void  tesselate ();

protected:
  G3DVector3d _e1, _e2, _e3;  //Position + geometry of the prisma

  G3DVector3d _points[6]; //TODO points
  G3DVector3d _norm[5];

  static Field FieldList_[3];

};


#endif
