/*
 * Project : "MindsEye"
 * Copyright 1996, 1998. All Rights Reserved.
 * Author(s) Frank Meier, M. Kuball
 *
 * $Id: plinit.cpp,v 1.1.1.1 1999/09/09 23:48:42 iamcliff Exp $
 *
 *
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 * OVERVIEW
 * ========
 * Define the entry points for the plugin loader.
 */

#include "include/config.h"
#include "kernel/plugin/classinfo.h"
#include "kernel/m_core.h"
#include "material/mat_widget.h"
#include "shader.h"
#include "shaderWidget.h"


G3DAttribute* createRibShader( void );
QFrame*       createShaderWidget( QWidget* );


const char* pluginDescription = "Attribute class and widget for RIB shader";
const char* pluginCopyright   = "Copyright 1998 by Martin Kuball";
unsigned    pluginVersion     = EHNO_VERSION;


int
pluginInit( MCore *kernel )
{
  TMatWidget *pair;

  pair = new TMatWidget;
  pair->name    = RIBShaderWidget::GetDescription();
  pair->aname   = RIBShaderWidget::GetAttributeType();
  pair->factory = createShaderWidget;
  kernel->addMaterialWidget( pair );

  kernel->addAttributeFactory( G3DARibShader::GetTypeName(),
			       createRibShader );

  return( 1 );
}

int
pluginClose( void )
{
}



G3DAttribute*
createRibShader( void )
{
  return( new G3DARibShader );
}

QFrame*
createShaderWidget( QWidget *parent )
{
  return( new RIBShaderWidget(parent) );
}


//=================================END==============================
