/*
 * Project : "MindsEye, 3D library"
 * Copyright 1996, 1997. All Rights Reserved.
 * Author(s): M. Kuball
 *
 * $Id: shader.h,v 1.2 2002/06/17 20:28:25 ainvar Exp $
 *
 * 
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef _RIB_SHADER_
#define _RIB_SHADER_

#include "include/config.h"
#include "3dlib/Attributes/texture.h"


class G3DARibShader : public G3DATexture
{
 public:
  G3DARibShader () { type_ = 0; }
  G3DARibShader( const G3DARibShader& ) { type_ = 0; }
  ~G3DARibShader();

    ///Set the corresponding OpenGL state variables.
  virtual void activate () const;
  virtual G3DAttribute* copy () const;
    ///Return a list with the names and types of the object s parameter.
  virtual const Field* getFieldList () const;
    /**Get a list of params describing the geometry of the object.
       If plist is Null you get just the number of elements.*/
  virtual uint  getParameter( Param* );
    ///Return a Descriptive name of the shape.
  virtual const char* getTypeName () const;
    ///Return a Descriptive name of the shape.
  static  const char* GetTypeName ();

  //TODO add methods to get and set state

    ///Set the user visible values of the attribute to the values of atr.
  virtual void  setValues( const G3DAttribute *atr );

protected:
  const char *shaderName_;

  static Field FieldList_[1];

};


#endif
