/*
 * Project : "MindsEye, 3D library"
 * Copyright 1996, 1997. All Rights Reserved.
 * Author(s): M. Kuball
 *
 * $Id: anim_spin.h,v 1.2 2002/06/17 20:28:25 ainvar Exp $
 *
 * 
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * OVERVIEW
 * ========
 * basic attribute classes
 *
 */

#ifndef __ANIMATION_SPIN_H_
#define __ANIMATION_SPIN_H_

#include "animation.h"


/**An animation attribute that rotates the associated object around an
   axis with constant velocity.
 */
class G3DAnimationSpin : public G3DAnimation
{
  DECLARE_ADYN

public:
  G3DAnimationSpin () : G3DAnimation(0), axis_(1,0,0)
    { type_ = TA_ANIM_SPIN;  rotationSpeed_ = 0; }
  G3DAnimationSpin( const G3DAnimationSpin& );

  virtual void evaluateAt( G3DObject*, float t ) const;
  virtual void saveValueAt( const G3DObject*, float t );
    ///Return a list with the names and types of the object s parameter.
  virtual const Field* getFieldList () const;
    /**Get a list of params describing the geometry of the object.
       If plist is Null you get just the number of elements.*/
  virtual uint  getParameter( Param* );
  virtual void  setParameter( const Param* );
    ///Set the user visible values of the attribute to the values of atr.
  virtual void  setValues( const G3DAttribute *atr );

protected:
  G3DVector3d axis_;
  G3DPoint3d  center_;
  float       rotationSpeed_;

  static Field FieldList_[3];

};

#endif
