/*
 * Project : "MindsEye, 3D library"
 * Copyright 1996, 1997. All Rights Reserved.
 * Author(s): M. Kuball
 *
 * $Id: reference.cpp,v 1.2 2002/06/17 18:18:14 ainvar Exp $
 *
 * 
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include "include/config.h"
#include <GL/gl.h>
#include <GL/glu.h>

#include "reference.h"

//IMPLEMENT_ADYN(G3DAReference, "Reference")

void
G3DAReference::activate () const
{
  ref_->activate();
}

G3DAttribute*
G3DAReference::copy () const
{
  return( new G3DAReference(ref_) );
}

const Field*
G3DAReference::getFieldList () const
{
  return( ref_->getFieldList() );
}

uint
G3DAReference::getParameter( Param *pList )
{
  return( ref_->getParameter(pList) );
}

const G3DAttribute*
G3DAReference::getReference () const
{
  return ref_;
}

const char*
G3DAReference::getTypeName () const
{
  return( ref_->getTypeName() );
}

int
G3DAReference::isMono ()
{
  return( ref_->isMono() );
}

void
G3DAReference::dispose ()
{
  ref_->dispose();
  delete this;  //TODO
}

void
G3DAReference::setValues( const G3DAttribute *src )
{
  ref_->setValues( src );
}


//==================================END================================
