/*
 * Project : "MindsEye, 3D library"
 * Copyright 1996, 1997. All Rights Reserved.
 * Author(s): M. Kuball
 *
 * $Id: reference.h,v 1.2 2002/06/17 20:28:25 ainvar Exp $
 *
 * 
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef _A_REFERENCE_H_
#define _A_REFERENCE_H_

#include "attribute.h"


/**An Object of this class references another attribute. It is used
   to share attributes beween objects.
 */
class G3DAReference : public G3DAttribute
{
public:
//TODO make this private and provide a function that guarantees
// to return a pointer
    ///Create a reference to ref.
  G3DAReference( G3DAttribute *ref )
    {
      ref_ = ref;
      ref_->addReference();
      type_ = ref->getType();
    };

  virtual G3DAttribute* copy () const;
    ///
  virtual void dispose ();
    ///
  virtual void activate () const;
    ///Return a list with the names and types of the object s parameter.
  virtual const Field* getFieldList () const;
    /**Get a list of params describing the geometry of the object.
       If plist is Null you get just the number of elements.*/
  virtual uint  getParameter( Param* );
    ///
  virtual const G3DAttribute* getReference () const;
    ///Return a Descriptive name of the shape.
  virtual const char* getTypeName () const;
  virtual int   isMono ();
    ///Is attribute a reference to . 
  virtual bool  isReference () const { return( true ); }
    ///Set the user visible values of the attribute to the values of atr.
  virtual void  setValues( const G3DAttribute *atr );

protected:
  G3DAttribute *ref_;
};

#endif
