/*
 * Project : "MindsEye, 3D library"
 * Copyright 1996, 1997. All Rights Reserved.
 * Author(s): M. Kuball
 *
 * $Id: resol.cpp,v 1.2 2002/06/17 18:18:14 ainvar Exp $
 *
 * 
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include "include/config.h"
#include <GL/gl.h>
#include <GL/glu.h>
#include "resl.h"


IMPLEMENT_ADYN(G3DAResolution, "Resolution")


Field G3DAResolution::FieldList_[1] = { {"quality", s_flt} };

const Field*
G3DAResolution::getFieldList () const
{
  return( FieldList_ );
}

uint
G3DAResolution::getParameter( Param *pList )
{
  if( pList )
    {
      pList->flt  = quality_;
    }
  return( 1 );
}

void
G3DAResolution::setValues( const G3DAttribute *src )
{
  if( src->getType() == type_ )
    {
      quality_ = ((G3DAResolution*)src)->quality_;
      //style_   = ((G3DAResolution&)src).style_;
    }
}


//==================================END================================
