/*
 * Project : "MindsEye, 3D library"
 * Copyright 1996, 1997. All Rights Reserved.
 * Author(s): M. Kuball
 *
 * $Id: actions.cpp,v 1.1.1.1 1999/09/09 23:48:50 iamcliff Exp $
 *
 *
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include "actions.h"
#include "sceneElement.h"
#include "shape.h"
#include "Attributes/animation.h"
#include "t_objects.h"


EvalState
AnimateAction::evaluate( G3DObject *obj )
{
  if( IS_CLASS(obj->getType(), T_SCENE_ELEMENT) )  //TODO animate all?
    {
      if( !(obj->getState() & selected) )
	{
	  G3DSceneElement *elem = (G3DSceneElement*)obj;
	  G3DAListIterator  itr = elem->getAttribute( TA_ANIMATION );
	  while( *itr )
	    {
	      ((G3DAnimation*)*itr)->evaluateAt( elem, time_ );
	      ++itr;
	    }
	}
    }
  return( continueEval );
}


//------------------------------------------------------------------


void
GenericAction::postAction( G3DObject* )
{
}


EvalState
DeleteListAction::evaluate( G3DObject *obj )
{
  if( !IS_SUBTYPE(obj->getType(), T_GROUP) )
    ((G3DShape*)obj)->deleteList();
  return( continueEval );
}


//-------------------------------------------------------------------


EvalState
FindByName::evaluate( G3DObject *obj )
{
  
  if( obj->getName() && (strcmp(obj->getName(), name_) == 0) )
    {
      result_ = obj;
      return stopEval;
    }
  return( continueEval );
}


//-------------------------------------------------------------------


EvalState
SetTimeAction::evaluate( G3DObject *obj )
{
  if( IS_CLASS(obj->getType(), T_SCENE_ELEMENT) )
    {
      G3DSceneElement *elem = (G3DSceneElement*)obj;
      G3DAListIterator attr = elem->getAttribute( TA_ANIMATION );
      while( *attr )
	{
	  ((G3DAnimation*)*attr)->evaluateAt( elem, time_ );
	  ++attr;
	}
    }
  return( continueEval );
}

//===================================END===============================
