/*
 * Project : "MindsEye, 3D library"
 * Copyright 1996, 1997. All Rights Reserved.
 * Author(s): M. Kuball
 *
 * $Id: g3d_math.h,v 1.1.1.1 1999/09/09 23:48:59 iamcliff Exp $
 *
 * 
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef __GENERIC_H_
#define __GENERIC_H_

#include <math.h>

typedef unsigned int uint;

const MeFloat FG_EPSILON   = 1.0E-8;
const MeFloat FG_AEPSILON  = 0.5E-3;  //used with angles
const MeFloat FG_MAX       = 1.0E20;  //used for bounding box
const MeFloat G3D_INFINITY = 1.0E100;


#include "math/g3dvector.h"
#include "math/g3dpoint.h"

typedef G3DVector3<MeFloat> G3DVector3d;
typedef G3DPoint3<MeFloat>  G3DPoint3d;

#include "math/matrix.h"
#include "math/g3d_ray.h"
#include "math/quaternion.h"


inline MeFloat deg2rad(const MeFloat deg) { return (deg/180)*M_PI; }
inline MeFloat rad2deg(const MeFloat rad) { return rad * 180/M_PI; }

inline double max( double x, double y )
{
  return( (x >= y) ? x : y );
}

inline float max( float x, float y )
{
  return( (x >= y) ? x : y );
}

inline double min( double x, double y )
{
  return( (x >= y) ? y : x );
}

inline float min( float x, float y )
{
  return( (x >= y) ? y : x );
}


#endif
