/*
 * Project : "MindsEye, 3D library"
 * Copyright 1996, 1997. All Rights Reserved.
 * Author(s): M. Kuball
 *
 * $Id: g_operator.cpp,v 1.1.1.1 1999/09/09 23:49:01 iamcliff Exp $
 *
 *
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include "include/config.h"
#include "g_operator.h"
#include "sceneElement.h"
#include "shape.h"
#include "widget.h"



bool
G3D_Operator::cexec( const G3DObject* )
{
  return false;
}

bool
G3D_Operator::exec( G3DObject* )
{
  return false;
}


//-----------------------------------------------------------------------


bool
G3D_CompileListOp::exec( G3DObject *obj )
{
  ((G3DShape*)obj)->compileList( num_ );
  return( false );
}

template<class T>
bool
G3D_DisplayOp<T>::cexec( const G3DObject *obj )
{
  ((const T*)obj)->display( lnum_ );
  return( false );
}


//template<class T>
bool
G3D_SelectionOp::exec( G3DObject *obj )
{
  glLoadName( num_++ );
  ((G3DSceneElement*)obj)->select();
  return(false);
}


//----------------------------------------------------------------


bool
G3D_MoveOp::exec( G3DObject *obj )
{
  obj->setOrigin( obj->getOrigin() + tl_ );
  return( false );
}


//----------------------------------------------------------------


bool
G3D_SendActionOp::exec( G3DObject *obj )
{
  obj->doAction( action_ );
  return(false);
}


//----------------------------------------------------------------


#ifdef EXPLICIT_TEMPLATES
#ifdef __GNUG__

//template class G3D_SelectionOp
//template class GSelectionIterator<G3DLight>;
//template class GSelectionIterator<G3DShape>;
template class G3D_DisplayOp<G3DSceneElement>;
template class G3D_DisplayOp<G3DWidget>;
#else

void  Vector_dumbSPARC()
{
}

#endif
#endif  //EXPLICIT_TEMPLATES


//==================================END===============================
