/*
 * Project : "MindsEye, 3D library"
 * Copyright (c) 1995 - 1997. All Rights Reserved.
 * Author(s): P. Lavoie, M. Kuball
 *
 * $Id: ha_face.h,v 1.2 2001/04/01 09:42:28 ainvar Exp $
 *
 *
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 * OVERVIEW
 * ========
 *
 */

#ifndef _W_FACE_H_
#define _W_FACE_H_

#include "object.h"


class G3DConstraint;

/// A wrapper object used to control a face of a 3d object.
class G3DFace : public G3DObject
{
public:
  /// Constructor.
  G3DFace ( G3DPoint3d *vt, uint *faces, uint nfaces, G3DObject *parent );

  /// Destructor. Called when the object is destroyed.
  ~G3DFace ();
  
  /// Do a given action with this object.
  virtual void doAction ( ActionData& );

  /// Return the face's origin.
  virtual const G3DPoint3d& getOrigin () const;

  /// Set the face's constraint (?)
  void setConstraint ( const G3DConstraint* );
  
  /// Set the face's origin.
  virtual void setOrigin ( const TVector<MeFloat,3>& );
  
  ///Set orientation of normal
  //virtual void setOrientation();
  
protected:
  G3DPoint3d *vertices_, *vertOrig_;
  uint       *faces_;
  uint       nfaces_;
};

#endif
