/*
 * Project : "MindsEye, Math"
 * Copyright (c) 1996, 1997, 1998 by Martin Kuball. All Rights Reserved.
 * Author(s):  M. Kuball
 *
 * $Id: g3d_ray.cpp,v 1.1.1.1 1999/09/09 23:50:34 iamcliff Exp $
 *
 *
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include "include/config.h"
#include "g3d_ray.h"


G3DRay::G3DRay( const G3DRay &orig )
{
  direction_  = orig.direction_;
  startpoint_ = orig.startpoint_;
  x  = orig.x;
  y  = orig.y;
}


MeFloat
G3DRay::getDistanceTo( const G3DPoint3d &p ) const
{
  MeFloat     tmp;
  G3DVector3d dist = p - startpoint_;

  tmp   = direction_.dot( dist );
  dist += direction_ * (-tmp);
  return( dist.lengthSquared() );
}


//==================================END==================================
