/*
 * Project : "MindsEye, 3D library"
 * Copyright 1996, 1997. All Rights Reserved.
 * Author(s): M. Kuball
 *
 * $Id: tools.h,v 1.2 2002/06/10 09:30:14 ainvar Exp $
 *
 * 
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef __MATRIX_TOOLS_H_
#define __MATRIX_TOOLS_H_

#include "matrix.h"
#include <nurbs++/matrixRT.h>

using namespace PLib ; 

inline void
convertMatrix( MatrixRT<MeFloat> &dst, G3DMatrix &src )
{
  const MeFloat *srcmem = (const MeFloat*)src;
  for( int j = 0; j < 4; ++j )
    for( int i = 0; i < 4; ++i )
      dst(i,j) = *(srcmem++);
}

inline void
convertVector( Point3Df &ppt, G3DVector3d &v )
{
  ppt.x() = v[0];
  ppt.y() = v[1];
  ppt.z() = v[2];
}

#endif
