/*
 * Project : "MindsEye, 3D library"
 * Copyright 1996, 1997. All Rights Reserved.
 * Author(s): M. Kuball
 *
 * $Id: pointstuff.h,v 1.1.1.1 1999/09/09 23:49:14 iamcliff Exp $
 *
 *
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef _POINTSTUFF_H_
#define _POINTSTUFF_H_

#include "g3d_math.h"

class G3DCamera;
class G3DRay;

namespace PLib {
    template<class T> class Vector;
    template<class T> class Matrix;
}

using PLib::HPoint3Df;

int
findNearestPoint( const G3DCamera& cam, const G3DRay &ray,
		  const G3DMatrix &wtrafo, const G3DPoint3d *pt,
		  uint num, MeFloat& radius );
int
findNearestCPointV( const G3DCamera& cam, const G3DRay &ray,
		    const G3DMatrix &wtrafo,
		    const PLib::Vector<HPoint3Df> &pt,
		    MeFloat& radius );
bool
findNearestCPointM( const G3DCamera& cam, const G3DRay &ray,
		    const G3DMatrix &wtrafo,
		    const PLib::Matrix<HPoint3Df> &pt,
		    MeFloat& radius, int&, int& );
MeFloat
distanceToLine( MeFloat* line, MeFloat mx, MeFloat my, MeFloat rad );

int
polygonTest( const G3DRay &ray, const G3DMatrix &wtrafo,
	     const G3DPoint3d *pt, uint *index, uint num );

#endif
