/*
 * Project : "MindsEye, 3D library"
 * Copyright 1996, 1997. All Rights Reserved.
 * Author(s): M. Kuball
 *
 * $Id: t_fields.h,v 1.4 2002/06/11 18:21:05 ainvar Exp $
 *
 *
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef _T_FIELDS_H
#define _T_FIELDS_H

#include <nurbs++/specialType.h>


class G3DColor;

namespace PLib{
  template<class T> class Vector;
  template<class T> class Matrix;
}

using PLib::HPoint3Df;

enum ParamType
{ s_point3=0, s_vector3, s_ctrlPt, s_color, s_flt,
  s_number, s_logic, s_string,
  m_point3, m_vector3, m_vctrlPt, m_color, m_flt,
  m_number, m_logic, m_string, m_mctrlPt
};


typedef struct
{
  char      *name;
  ParamType type;
} Field;
//TODO better name: ParamInfo

typedef union
{
  const PLib::Vector<HPoint3Df> *vCtrlPt;
  const PLib::Matrix<HPoint3Df> *mCtrlPt;
  G3DPoint3d  *point3;
  G3DVector3d *vector3;
  HPoint3Df   *ctrlPt;
  G3DColor    *color;
  MeFloat     *fltList;
  uint        *numList;
  MeFloat     flt;
  uint        number;
  bool        logic;
  char        *string;
  char        **strList;
} Param;

#endif
