/*
 * Project : "MindsEye, 3D library"
 * Copyright 1996, 1997. All Rights Reserved.
 * Author(s): M. Kuball
 *
 * $Id: w_dlight.h,v 1.2 2001/04/01 09:42:28 ainvar Exp $
 *
 *
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef __Direct_LIGHT_WIDGET_H_
#define __DIRECT_LIGHT_WIDGET_H_

#include "widget.h"
#include "s_simple.h"

class G3DLight;


/// 3d widget for directional light sources.
/** A Widget object is drawn around a selected Object to visualize its
    bounding box and to supply handle to size or rotate the object (?)
    The Widget itself is never selected, only its parent: the light.
*/
class G3DDirectLightShape : public G3DWidget
{
public:
  /// Constructor taking the parent light as argument.
  G3DDirectLightShape ( G3DLight *parent );

  /// Display an object on the screen.
  /** Display the object on the screen. This will issue the necessary OGL 
      commands.
  */
  virtual void display ( int& ) const;
  
  /// Do a given action with this object.
  virtual void doAction ( ActionData &action );

  /// Recalculate the widget from its parent s bounding box.
  virtual void reset ();

protected:
  G3DS_Cone     cone_;
  G3DS_Cylinder cylinder_;
};

#endif
