/*
 * Project : "MindsEye, 3D library"
 * Copyright 1996, 1997. All Rights Reserved.
 * Author(s): M. Kuball
 *
 * $Id: w_orbit.h,v 1.2 2001/04/01 09:42:28 ainvar Exp $
 *
 *
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef _ORBIT_WIDGET_H_
#define _ORBIT_WIDGET_H_

#include "widget.h"

class G3DShape;


/// Widget drawing a bounding box and providing resize and rotation handles.
/** A Widget object is drawn around a selected Object to visualize its
    bounding box and to supply handle to size or rotate the object.
*/
class G3DOrbitWidget : public G3DWidget
{
public:
  /// Constructor taking the parent object as argument.
  G3DOrbitWidget ( G3DShape* );

  /// Display the widget on the screen.
  /** Display the widget on the screen. This will issue the necessary OGL 
      commands.
  */
  virtual void  display ( int n=0 ) const;
  
  /// Do a given action with this object.
  virtual void doAction ( ActionData &action );
  
  /// Return the origin of local coordinate system.
  virtual const G3DPoint3d& getOrigin () const;

  /// Select details of an object (picking ?).
  virtual void select ();

  /// Set origin of local coordinate system.
  virtual void setOrigin ( const TVector<MeFloat,3>& );

protected:
  // protected ?; not inherited virtual ?
  /// 
  void reset ();

protected:
  G3DPoint3d  ocenter_, anchor_;
  G3DPoint3d  _vertices[16]; // _triangles[8];
  //G3DVector3d _unScale;
  GLuint      selVertex_;
};

#endif
