/*
 * Project : "MindsEye"
 * Copyright (c) 1998. All Rights Reserved.
 * Author(s):   Martin Kuball
 * 
 * $Id: w_plight.cpp,v 1.2 2002/06/17 18:18:14 ainvar Exp $
 *
 *
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */


#include <stdlib.h>
#include <GL/gl.h>

#include "light.h"
#include "w_plight.h"
#include "t_actions.h"



G3DPointLightShape::G3DPointLightShape( G3DLight *parent ) :
  G3DWidget( parent ), sphere_( 0.5 )
{
  type_ = TW_POINT_LIGHT;
  reset();
}


void
G3DPointLightShape::display( int& ) const
{
  glPushAttrib( GL_CURRENT_BIT | GL_LIGHTING_BIT );
  glDisable( GL_LIGHTING );
  glColor3fv( (const float*)(((G3DLight*)parent_)->getColor()) );
  if( trafo_ )
    {
      glPushMatrix();
      glMultMatrixx( (const MeFloat*)trafo_ );
    }
  sphere_.shade( 0 );
  if( trafo_ )
    glPopMatrix();
  glPopAttrib();
}

void
G3DPointLightShape::doAction( ActionData &action )
{
  if( action.type == A_SELECT )
    {
    }
  else if( action.type == A_FIND_SELECTION )
    {
      //TODO no handles, yet
      ((SelectData&)action).setSelection( parent_ );
    }
}

void
G3DPointLightShape::reset ()
{
}


//================================END====================================
