/*
 * Project : "MindsEye, 3D library"
 * Copyright 1996, 1997. All Rights Reserved.
 * Author(s): M. Kuball
 *
 * $Id: w_scale.h,v 1.2 2001/04/01 09:42:28 ainvar Exp $
 *
 *
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef __SCALE_WIDGET_H_
#define __SCALE_WIDGET_H_

#include "widget.h"

class G3DShape;


/// Widget drawing a bounding box and providing resize handles.
/** A Scale Widget is drawn around a selected Object to visualize its
    bounding box and to supply handles to size the object.
*/
class G3DScaleWidget : public G3DWidget
{
public:
  /// Constructor taking the parent object as argument.
  G3DScaleWidget ( G3DShape* );

  /// Display the widget on the screen.
  /** Display the widget on the screen. This will issue the necessary OGL 
      commands.
  */
  virtual void display ( int& ) const;
  
  /// Do a given action with this object.
  virtual void doAction ( ActionData &action );
  
  ///
  void getFrameAtHandle ( G3DVector3d&, G3DVector3d&, G3DVector3d& );
  
  ///
  void getHandlePosition ( G3DPoint3d& ) const;

  /// Get the vertex opposite of the selected handle.
  const G3DPoint3d& getFixpoint () const;
  
  /// Recalculate the widget from its parent s bounding box.
  virtual void  reset ();
  
  /// Select details of an object (picking ?).
  virtual MeFloat select ( const G3DCamera&, const G3DRay&, G3DPartEnum );

protected:
  ///
  void  calculateVertices ( const G3DPoint3d&, const G3DVector3d&,
			    const G3DVector3d&, const G3DVector3d& );

protected:
  G3DPoint3d  vertices_[16]; //, _triangles[8];
  //G3DVector3d _rotaxes, _unScale;
  GLuint      selVertex_;
};

#endif
