/*
 * Project : "MindsEye"
 * Copyright (c) 1998 - 2001. All Rights Reserved.
 * Author(s):   Martin Kuball
 * 
 * $Id: widget.cpp,v 1.3 2002/06/17 18:18:14 ainvar Exp $
 *
 *
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */


#include "widget.h"



G3DWidget::G3DWidget ( G3DObject *parent ) :
  G3DObject( parent )
{
}

G3DObject*
G3DWidget::copy () const
{
  return 0;
}

const G3DQuaternion&
G3DWidget::getOrientation () const
{
  return (parent_->getOrientation());
}

void
G3DWidget::getLocalTrafo ( G3DMatrix &m ) const
{
  parent_->getLocalTrafo (m);
}

const G3DPoint3d&
G3DWidget::getOrigin () const
{
  return (parent_->getOrigin());
}

const G3DVector3d&
G3DWidget::getScale () const
{
  return (parent_->getScale());
}

void
G3DWidget::getWorldTrafo ( G3DMatrix &m, bool local ) const
{
  parent_->getWorldTrafo (m, local);
}

void
G3DWidget::reset ()
{
}

void
G3DWidget::setOrientation ( const G3DQuaternion &quat,
			    const TVector<MeFloat,3> &p,
			    const TVector<MeFloat,3> &o )
{
  parent_->setOrientation (quat, p, o);
}

void
G3DWidget::setOrigin ( const TVector<MeFloat,3> &delta )
{
  parent_->setOrigin (delta);
}

void
G3DWidget::setScale ( const TVector<MeFloat,3> &scale )
{
  parent_->setScale (scale);
}

//================================END====================================
