/*
 * Project : "MindsEye"
 * Copyright (c) 1997. All Rights Reserved.
 * Atuhor(s): M. Kuball
 *
 * $Id: plconfig.cpp,v 1.2 2002/06/17 18:18:14 ainvar Exp $
 *
 *
 * COPYRIGHT
 * ========= 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 * OVERVIEW
 * ========
 * A dialog  for viewing and editing the scene graph. It's based on
 * ktreelisttest from Keith Brown.
 *
 */

#include "include/config.h"
#include <qlistview.h>
#include <qpushbt.h>
#include <qlayout.h>
#include <qlabel.h>
//#include <qpopmenu.h>
//#include <qkeycode.h>
#include <qlineedit.h>
#include <qdir.h>
#include <qfile.h>
#include <qfileinfo.h>

#include "kernel/core.h"
#include "plconfig.h"

MEPlConfigDlg::MEPlConfigDlg (): //( int module_id, int load_t ) :
  //  MEModule(module_id, load_t, "MEPlConfigDialog" )
    QWidget( NULL )
{
  selectedItem_ = NULL;

  QVBoxLayout *gm    = new QVBoxLayout( this, 6 );
  QHBoxLayout *gm_00 = new QHBoxLayout;
  QHBoxLayout *gm_01 = new QHBoxLayout;
  QHBoxLayout *gm_02 = new QHBoxLayout;
  //QHBoxLayout *gm_03 = new QHBoxLayout;
  gm->addLayout( gm_00, 100 );
  gm->addLayout( gm_01, 3 );
  gm->addLayout( gm_02, 3 );
  //gm->addSpacing( 5 );

  listView_ = new QListView( this );
    listView_->setFrameStyle( QFrame::WinPanel | QFrame::Sunken );
    listView_->addColumn( "plugin" );
    listView_->addColumn( "l.o.s." );
    listView_->addColumn( "loaded" );
    listView_->addColumn( "description" );
    //listView_->header()->hide();
    listView_->setSorting( -1 );
    listView_->setMultiSelection( false );  //TODO
    //listView_->setColumnWidthMode( 0, QListView::Manual );
    //listView_->setRootIsDecorated( true );
    listView_->setMinimumSize( 100, 100 );
    connect( listView_, SIGNAL(currentChanged(QListViewItem*)),
	     SLOT(setCurrent(QListViewItem*)) );
    gm_00->addWidget( listView_, 80 );

  QLabel *label = new QLabel("Dir 1", this);
    label->setAlignment( AlignHCenter|AlignVCenter );
    label->setFixedSize( label->sizeHint() );
    gm_01->addWidget( label, 1 );
  dir1_ = new QLineEdit( this ); //TODO use this for value editing
    dir1_->setMinimumSize( 40, 20 );
    gm_01->addWidget( dir1_, 100 );
  QPushButton *pbtn = new QPushButton( "search...", this );
    pbtn->setMinimumSize( 50, 20 );
    gm_01->addWidget( pbtn, 1 );
    connect( pbtn, SIGNAL(clicked()), SLOT(setDir1()) );

  //gm_01->addSpacing( 5 );

  pbtn = new QPushButton( "Close", this );
  pbtn->setMinimumSize( 60, 20 );
  connect( pbtn, SIGNAL(clicked()), this, SLOT(closeIt()) );
  gm_02->addWidget( pbtn, 0 );
  gm_02->addStretch( 100 );

  pbtn = new QPushButton( "Scan new", this );
  pbtn->setMinimumSize( 60, 20 );
  connect( pbtn, SIGNAL(clicked()), SLOT(scanNewFiles()) );
  gm_02->addWidget( pbtn, 0 );
  pbtn = new QPushButton( "Scan all", this );
  pbtn->setMinimumSize( 60, 20 );
  connect( pbtn, SIGNAL(clicked()), SLOT(scanAllFiles()) );
  gm_02->addWidget( pbtn, 0 );
  pbtn = new QPushButton( "apply", this );
  pbtn->setMinimumSize( 60, 20 );
  gm_02->addWidget( pbtn, 0 );

  searchDirectory( "../plugins" );
  gm->activate ();
  setMinimumSize( 200, 300 );
  resize( 300, 300 );

}


void
MEPlConfigDlg::closeIt()
{
  close( );
}

void
MEPlConfigDlg::queryPlugin( QFileInfo *f )
{
  DllInfo *info = pmg_.queryDll( f->filePath() );
  if( info )
    {
      QListViewItem *tmp = 
	new QListViewItem( listView_, info->name_, "no", "no",
			   info->description_ );
      /*
      QCheckListItem *tmp =
	new QCheckListItem( listView_, " ", //(const char*)f->fileName(),
			    QCheckListItem::CheckBox );
      tmp->setText( 2, (const char*)f->fileName() );
      */
      delete info;
    }
}

void
MEPlConfigDlg::scanAllFiles()
{
  listView_->clear();
  searchDirectory( dir1_->text() );
}

void
MEPlConfigDlg::scanNewFiles()
{
}

void
MEPlConfigDlg::setCurrent( QListViewItem *item )
{
  /*
  if( item )
  {
    MeViewItem *tmp = (MeViewItem*)item;
    selectedItem_ = tmp;
    G3DObject  *obj = tmp->getObject();
    if( obj )
      {
	  _nameEdit->setText( obj->getName() );
      }
    }
  else
    selectedItem_ = NULL;
  */
}

void
MEPlConfigDlg::setDir1()
{
}

void
MEPlConfigDlg::searchDirectory( const char *dirname )
{
  //iostream lfile( ".list" );
  //search the directory, open all plugins, get the desc
  //and close them
  //add everything to the list file

  QDir thisDir( dirname );
  if( !thisDir.isReadable() )
    {
      //readable = FALSE;
      return;
    }

  const QFileInfoList *files = thisDir.entryInfoList();
  if( files )
    {
      QFileInfoListIterator it( *files );
      QFileInfo *f;
      DllInfo   *pinfo;
      while( (f = it.current()) != 0 )
	{
	  ++it;
	  if( f->fileName() == "." || f->fileName() == ".." )
	    ; // nothing
	  else if( f->isSymLink() )
	    ;
	  else if( f->isDir() )
	    ;
	  else if( f->isFile() )
	    {
	      queryPlugin( f );
	    } 
	}
    }
}


//==================================END==================================
