/*
 * Project : "MindsEye"
 * Copyright (c) 1997 - 1998. All Rights Reserved.
 * Atuhor(s): M. Kuball
 *
 * $Id: plconfig.h,v 1.3 2002/06/17 20:28:25 ainvar Exp $
 *
 *
 * COPYRIGHT
 * ========= 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 * OVERVIEW
 * ========
 * A dialog  for viewing and editing the scene graph. It's based on
 * ktreelisttest from Keith Brown.
 *
 */

#ifndef _PLUGIN_CONFIG_H
#define _PLUGIN_CONFIG_H

#include <qwidget.h>
#include "kernel/plugin/dll.h"
//#include "kernel/world_list.h"

class QListView;
class QListViewItem;
class QLineEdit;
class QFileInfo;


/**A dialog with a tree list of the scene graph.
 */
class MEPlConfigDlg : public QWidget
{
  Q_OBJECT

public:
  MEPlConfigDlg ();

protected:
  void queryPlugin( QFileInfo *f );
  
protected slots:
  void closeIt();
  void scanAllFiles();
  void scanNewFiles();
  void searchDirectory( const char* );
  void setCurrent( QListViewItem* );
  void setDir1();

protected:
      ///
    QListView     *listView_;
      ///
    QListViewItem *selectedItem_;
    QLineEdit     *dir1_;

    MEPluginManager pmg_;

};

#endif
