/*
 * Project : "MindsEye, NURBS editor"
 * Copyright: 1998. All Rights Reserved.
 * Author(s): P. Lavoie, M. Kuball
 *
 * $Id: vedit.cpp,v 1.2 2002/06/17 18:18:14 ainvar Exp $
 *
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include "include/config.h"
#include <qlined.h>
#include "vedit.h"


MEVectorEdit::MEVectorEdit( QWidget *parent ) :
  QWidget(parent)
{
  input1_ = new QLineEdit( this );
  input2_ = new QLineEdit( this );
  input3_ = new QLineEdit( this );
  resize( 20, 20 );
}

MEVectorEdit::~MEVectorEdit()
{
	delete input3_;
	delete input2_;
	delete input1_;
}


void
MEVectorEdit::erase ()
{
  input1_->setText( "" );
  input2_->setText( "" );
  input3_->setText( "" );
}

void
MEVectorEdit::getVector( G3DVector3d &v ) const
{
  v[0] = atof( input1_->text() );
  v[1] = atof( input2_->text() );
  v[2] = atof( input3_->text() );
}

void
MEVectorEdit::resizeEvent( QResizeEvent* )
{
  int h = height();
  int w = width() / 3;
  input1_->setGeometry( 0, 0, w, h );
  input2_->setGeometry( w, 0, w, h );
  input3_->setGeometry( w+w, 0, w, h );
}

void
MEVectorEdit::setVector( const G3DVector3d &v )
{
  QString str;
  str.setNum( v[0], 'f', 3 );
  input1_->setText( str );
  str.setNum( v[1],  'f', 3 );
  input2_->setText( str );
  str.setNum( v[2],  'f', 3 );
  input3_->setText( str );
}



//===================================END=================================
