/*
 * Project : "MindsEye, NURBS editor"
 * Copyright 1996, 1997. All Rights Reserved.
 * Author(s): P. Lavoie, M. Kuball
 *
 * $Id: vedit.h,v 1.2 2002/06/17 20:28:25 ainvar Exp $
 *
 *
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef _VECTOR_EDIT_H_
#define _VECTOR_EDIT_H_

#include "include/config.h"
#include <qwidget.h>
#include "3dlib/g3d_math.h"

class QLineEdit;

class MEVectorEdit : public QWidget
{
  Q_OBJECT

public:
  MEVectorEdit( QWidget* );
  ~MEVectorEdit();

  void erase ();
  void getVector( G3DVector3d& ) const;
  void setVector( const G3DVector3d& );

protected:
  void resizeEvent( QResizeEvent* );

protected:
  QLineEdit *input1_, *input2_, *input3_;

};

#endif
