/*
 * Project : "MindsEye"
 * Copyright 1996. All Rights Reserved.
 * Atuhor(s): M. van Velsen
 * 
 * $Id: viewLayout.cpp,v 1.1.1.1 1999/09/09 23:51:34 iamcliff Exp $
 *
 *
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */ 

#include <qbuttongroup.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qpixmap.h>

#include "viewLayout.h"
#include "bild1.xpm"
#include "bild2.xpm"
#include "bild3.xpm"
#include "bild4.xpm"
#include "bild5.xpm"
#include "bild6.xpm"
#include "bild7.xpm"
#include "bild8.xpm"



MEViewlayoutDialog::MEViewlayoutDialog( int current )
{
  setCaption ("MindsEye Viewport Layout");

  QGridLayout *gl = new QGridLayout( this, 7, 9, 4, 4 );
  gl->addRowSpacing( 0, 50 );
  gl->addRowSpacing( 1, 20 );
  gl->addRowSpacing( 2, 10 );
  gl->addRowSpacing( 3, 50 );
  gl->addRowSpacing( 4, 20 );
  gl->addRowSpacing( 5, 20 );
  gl->setRowStretch( 5, 100 );
  gl->addRowSpacing( 6, 25 );

  gl->addColSpacing( 0, 10 );
  gl->setColStretch( 0, 10 );
  gl->addColSpacing( 1, 50 );
  gl->addColSpacing( 2, 10 );
  gl->setColStretch( 2, 10 );
  gl->addColSpacing( 3, 50 );
  gl->addColSpacing( 4, 10 );
  gl->setColStretch( 4, 10 );
  gl->addColSpacing( 5, 50 );
  gl->addColSpacing( 6, 10 );
  gl->setColStretch( 6, 10 );
  gl->addColSpacing( 7, 50 );
  gl->addColSpacing( 8, 10 );
  gl->setColStretch( 8, 10 );

  QLabel *lb = new QLabel( this );
  lb->setPixmap( QPixmap((const char**)bild1) );
  gl->addWidget( lb, 0, 1 );
  lb = new QLabel( this );
  lb->setPixmap( QPixmap((const char**)bild2) );
  gl->addWidget( lb, 0, 3 );
  lb = new QLabel( this );
  lb->setPixmap( QPixmap((const char**)bild3) );
  gl->addWidget( lb, 0, 5 );
  lb = new QLabel( this );
  lb->setPixmap( QPixmap((const char**)bild4) );
  gl->addWidget( lb, 0, 7 );
  lb = new QLabel( this );
  lb->setPixmap( QPixmap((const char**)bild5) );
  gl->addWidget( lb, 3, 1 );
  lb = new QLabel( this );
  lb->setPixmap( QPixmap((const char**)bild6) );
  gl->addWidget( lb, 3, 3 );
  lb = new QLabel( this );
  lb->setPixmap( QPixmap((const char**)bild7) );
  gl->addWidget( lb, 3, 5 );
  lb = new QLabel( this );
  lb->setPixmap( QPixmap((const char**)bild8) );
  gl->addWidget( lb, 3, 7 );

  QButtonGroup *bgroup = new QButtonGroup;
  bgroup->setExclusive( TRUE );
  connect( bgroup, SIGNAL(clicked(int)), SLOT(selectLayout(int)) );

  QPushButton *name = new QPushButton( "layout 1", this );
    name->setToggleButton( TRUE );
    bgroup->insert( name, 0  );
    gl->addWidget( name, 1, 1 );
  name = new QPushButton( "layout 2", this );
    name->setToggleButton( TRUE );
    bgroup->insert( name, 1  );
    gl->addWidget( name, 1, 3 );
  name = new QPushButton( "layout 3", this );
    name->setToggleButton( TRUE );
    bgroup->insert( name, 2  );
    gl->addWidget( name, 1, 5 );
  name = new QPushButton( "layout 4", this );
    name->setToggleButton( TRUE );
    bgroup->insert( name, 3  );
    gl->addWidget( name, 1, 7 );
  name = new QPushButton( "layout 5", this );
    name->setToggleButton( TRUE );
    bgroup->insert( name, 4  );
    gl->addWidget( name, 4, 1 );
  name = new QPushButton( "layout 6", this );
    name->setToggleButton( TRUE );
    bgroup->insert( name, 5  );
    gl->addWidget( name, 4, 3 );
  name = new QPushButton( "layout 7", this );
    name->setToggleButton( TRUE );
    bgroup->insert( name, 6  );
    gl->addWidget( name, 4, 5 );
  name = new QPushButton( "layout 8", this );
    name->setToggleButton( TRUE );
    bgroup->insert( name, 7  );
    gl->addWidget( name, 4, 7 );
  
  QPushButton *btn = new QPushButton( "OK", this );
  gl->addWidget( btn, 6, 1 );
  connect( btn, SIGNAL(clicked()), SLOT(closeIt()) );

  if( current >= 0 )
    selected_ = current;
  else
    selected_ = 0;
  bgroup->setButton( selected_ );

  gl->activate();
  resize( 280, 200 );
}

void
MEViewlayoutDialog::closeIt()
{
  emit setLayout( selected_ );
  close();
}

void
MEViewlayoutDialog::selectLayout( int type )
{
  selected_ = type;
}


//================================END===================================
