/*
 * vi:ts=4:sw=4:
 *
 * Project : "MindsEye"
 * Copyright 1996, 1997. All Rights Reserved.
 * Author(s) M. van Velsen, M. Kuball
 *
 * $Id: m_vars.h,v 1.3 2000/03/07 06:57:05 crjohnson Exp $
 * 
 *
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 * OVERVIEW
 * ========
 * The variables you find here will be the only global variables available 
 * througout the entire kernel source, so be carefull in the light of
 * memory leaks !!
 */

#ifndef __MVARS_H__
#define __MVARS_H__


//TODO move these to m_defs.h ??

#ifndef PATH_MAX
#define PATH_MAX 1024
#endif

enum {
	KERNEL_SANE = 0,  	// these are internal and do not have anything to do
	KERNEL_PANIC 		// with the message system
};

#ifdef OCCTEST
enum { NR_MODULES =  16};
enum { NR_ICONS =  13 };
#else
enum { NR_MODULES =  15};
enum { NR_ICONS =  12 };
#endif


enum { 
	MODULE_KERNEL =  -1, // primarily for message usage
	MODULE_CONSOLE =  0,
	MODULE_CONFIG,
	MODULE_SCRIPT,
	MODULE_TREEDLG,
	MODULE_ANIM,
	MODULE_MATERIAL,
	MODULE_MODEL,
	MODULE_VIEWER,
	MODULE_NET,
	MODULE_LOAD,
	MODULE_SAVE,
	MODULE_ABOUT,
	MODULE_HELP ,
	MODULE_OUTPUT,
	MODULE_SHAPER
#ifdef OCCTEST
	,MODULE_OCCTEST
#endif
};


//extern QPixmap *pm [];
//extern QPixmap *background;

//extern char data_tree_visible;
//extern char console_visible;
//extern char script_visible;

extern const char *CopyrightMessage;


#endif // __MVARS_H__
