/*
 * Project : "MindsEye, 3D library"
 * Copyright 1996, 1997. All Rights Reserved.
 * Author(s): M. van Velsen
 *
 * $Id: io_filter.h,v 1.2 2002/06/17 20:28:25 ainvar Exp $
 *
 * 
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef __IO_FILTER_H_
#define __IO_FILTER_H_

class MEFilter;
class MEFltFactory;

extern MEFltFactory* getFltFactoryMe3d ();
extern MEFltFactory* getFltFactoryPov ();


#define MAX_FILE_LENGTH   256

#define _3D_DATA  0
#define ANIMATION 1
#define MATERIAL  2
#define IMAGE     3
#define CONFIG    4

#define FORMAT_BINARY 0
#define FORMAT_TEXT   1

#define IO_AUTOMATIC        0x0   // Let MindsEye find out the right type
#define IO_FILTER_POV       0x100 // Persistence Of Vision, POVRAY
#define IO_FILTER_3DSBIN    0x200 // Autodesk 3d-studio format ( binary )
#define IO_FILTER_3DSASC    0x300 // Autodesk 3d-studio format ( ascii  ) 
#define IO_FILTER_ALIAS     0x400 // Alias Wavefront
#define IO_FILTER_LW        0x500 // LightWave
#define IO_FILTER_SOFTIM    0x600 // SoftImage
#define IO_FILTER_RIB       0x700 // Renderman
#define IO_FILTER_OBJ       0x800 // Object format
#define IO_FILTER_NFF       0x900 // Neutral file format
#define IO_FILTER_VRML      0xA00 // VRML 
#define IO_FILTER_DXF       0xB00 // Autodesk DXF format
#define IO_FILTER_MAX       0xC00 // Kinetix 3d-studio MAX format
#define IO_FILTER_TRUESP    0xD00 // Caligari TrueSpace
#define IO_FILTER_3DMF      0xE00 // Quickdraw 3DMF format
#define IO_FILTER_AC3D     0x1000 // AC3D format
#define IO_FILTER_ME3D     0x1100 // MindsEyes own format

#define FILE_DONE               0
#define FILE_WRITEERROR         1
#define FILE_DATACORRUPT        2

#define FILE_VALIDFORMAT        0
#define FILE_WRONGFORMAT        1
#define FILE_NOTCHECKABLE       2
#define FILE_WRONGVERSION       3
#define FILE_TYPENOTSUPPORTED   4
#define FILE_FUNCTIONNOTDEFINED 5

#define FILE_READERROR          1
#define FILE_DATACORRUPT        2
#define FILE_UNEXPECTEDEOF      3

#define READ_SUCCESS            0
#define READ_ERROR              1

#define WRITE_SUCCESS           0
#define WRITE_ERROR             1

#define NOT_SUPPORTED           1 
#define SUPPORTED               0   


#endif
