/*
 * Project : "MindsEye, IO library"
 * Copyright (c) 1996, 1997. All Rights Reserved.
 * Author(s): M. Kuball
 *
 * $Id: pov.h,v 1.2 2000/02/29 20:31:17 ainvar Exp $
 *
 *
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * OVERWIE
 * =======
 * NFF Format i/o module.
 * Some parts of this code are based on ideas taken from the Generic
 * graphics library (G1.6) from Ekkehard Beier.
 *
 */

#ifndef __POVRAY_H__
#define __POVRAY_H__

#include "fstream.h"
#include "io/io_base.h"


/**
 I/O class for reading and writing the "Neutral file format".
  Some parts of this code are based on ideas taken from the
  Generic graphics library (G1.6).
  Reading a nff file is easy because there is no hirarchy.
 */

class MEIoPov : public MEFilter
{
public:
    ///
  MEIoPov () {};
  
    ///
  virtual int  check_header ( char *fname );
    ///
  virtual int  getFormatInfo ( int type );
  void    saveRecursive ( G3DGroup* );

protected:
    ///
  virtual int  exitLoad ( int );
    ///
  virtual int  exitSave ( int );
    ///
  virtual int  initLoad ( const char *fname );
    ///
  virtual int  initSave ( const char *fname, int );
    ///
  virtual int  loadObjects ( G3DGroup* );
    ///
  virtual int  saveObjects ( G3DScene* );

    ///
  void    writeCamera ();
    ///
  void    writeHeader ();

protected:
  ofstream  outf_;
  ofstream  tos_;

};


/**
 */
class MEFltFactoryPov : public MEFltFactory
{
public:
  MEFltFactoryPov ();

  virtual MEFilter* createFilter ();
  virtual void      writeObject ( int id, G3DObject*, ostream& );
};


#endif
