/*
 * Project : "MindsEye"
 * Copyright (c) 1999. All Rights Reserved.
 * Author(s):  F. Meier, M. Kuball
 * 
 * $Id: init_attr.cpp,v 1.1.1.1 1999/09/09 23:56:19 iamcliff Exp $
 *
 *
 * COPYRIGHT
 * ========= 
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include "include/config.h"
#include "3dlib/Attributes/attribute.h"
#include "3dlib/Attributes/texture.h"
#include "3dlib/Attributes/metal.h"
#include "3dlib/Attributes/plastic.h"
#include "3dlib/Attributes/anim_spin.h"
#include "core.h"
#include "initialize.h"


#define ADD_ATTR(class_name) \
  kernel->addAttributeFactory(class_name::GetTypeName(),class_name::factory )


void
init3dAttributes( MCore *kernel )
{
  //  ADD_ATTR( G3DAResolution );
  ADD_ATTR( G3DAColor );
  ADD_ATTR( G3DAMetal );
  ADD_ATTR( G3DAPlastic );
  ADD_ATTR( G3DAnimationSpin );
}


//====================================END=================================
