/*
 * Project : "MindsEye"
 * Copyright (c) 1996, 1997. All Rights Reserved.
 * Author(s):  M. Kuball
 * 
 * $Id: init_palette.cpp,v 1.1.1.1 1999/09/09 23:56:21 iamcliff Exp $
 *
 *
 * COPYRIGHT
 * ========= 
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include "include/config.h"
#include "core.h"
#include "modeler/factories.h"
#include "3dlib/t_objects.h"
#include "initialize.h"


void
initPaletteWidgets( MCore *kernel )
{
  kernel->addPaletteWidget( T_SHAPE, (void*)createMaterialWidget );

  kernel->addPaletteWidget( T_CONE,  (void*)createConeWidget );
  kernel->addPaletteWidget( T_MESH,  (void*)createMeshWidget );
  kernel->addPaletteWidget( T_POLYGON, (void*)createPolygonWidget );
  kernel->addPaletteWidget( T_SCENE, (void*)createSceneInfo );
  kernel->addPaletteWidget( T_SPHERE,  (void*)createSphereWidget );
  kernel->addPaletteWidget( T_TORUS, (void*)createTorusWidget );
  kernel->addPaletteWidget( T_TRIGRID, (void*)createTrigridWidget );

  kernel->addPaletteWidget( T_LIGHT, (void*)createLightWidget );
  kernel->addPaletteWidget( T_POINT_LIGHT, (void*)createPLightWidget );

  kernel->addPaletteWidget( TA_ANIM_SPIN, (void*)createSpinWidget );
}


//====================================END=================================
