/*
 * Project : "MindsEye, core library"
 * Copyright (c) 1995 - 1997. All Rights Reserved.
 * Author(s): M. van Velsen, M. Kuball
 * 
 * $Id: module.cpp,v 1.3 2001/07/16 11:03:09 ainvar Exp $
 *
 * 
 * COPYRIGHT
 * ========= 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 * OVERVIEW
 * ========
 *
 */

#include "include/config.h"
#include "include/version.h"
#include "module.h"


MEModule::MEModule ( int module_id, int, const char *name ) :
  QWidget (0, name)
{
  id        = module_id;
  //core_pack = pack;
 
  m_info = new module_info;  //TODO why a pointer?
  m_info->major_version = MAJOR;  //TODO do we need this?
  m_info->minor_version = MINOR;
  m_info->patch_level   = PATCH;
  
  strcpy (m_info->module_name, "template module");  //TODO
}

MEModule::~MEModule ()
{
  delete m_info;
}

struct module_info*
MEModule::get_module_info () const
{
  return m_info;
}

void
MEModule::closeEvent ( QCloseEvent *e )
{
  emit close_me (id);   
  // QWidget::closeEvent (e);
}


//================================END===================================
