/*
 * Project : "MindsEye"
 * Copyright 1996, 1998. All Rights Reserved.
 * Author(s) Frank Meier, M. Kuball
 *
 * $Id: dll.h,v 1.2 2002/06/17 20:28:25 ainvar Exp $
 *
 *
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 * OVERVIEW
 * ========
 *
 */

#ifndef __EODLL_H__
#define __EODLL_H__

#include <vector>

#include "classinfo.h"


/**Objects of this class encapsulates information about a dll.
 */
class DllInfo
{
public:
  DllInfo( void* );
  ~DllInfo();

  //bool  operator==( const DllInfo& );

public:
  unsigned   version_;
  const char *name_;
  const char *description_;
  const char *author_;
  const char *helpText_;
  
protected:
  void       *handle_;

};


////////////////////////////////////////


class MEPluginManager
{
public:
  MEPluginManager () : plugins_(0) {}
  ~MEPluginManager();

  int       numDllsLoaded() const;
  DllInfo*  operator[] (int);

  bool      loadDllsFromDir(const char *dir, const char *wildcard);
  DllInfo*  queryDll( const char *pname );
  void      unloadAllDlls();

  void print();

protected:
  void      loadDll(const char *);

protected:
  vector<void*> plugins_;

};


#endif
