/*
 * Project : MindsEye, material editor
 * Copyright (c) 1996 - 1998
 * Author(s): M. van Velsen, M. Kuball
 * 
 * $Id: m_matv.cpp,v 1.3 2001/07/12 00:47:11 ainvar Exp $
 *
 * 
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 * OVERVIEW
 * ========
 *
 */

#include "include/config.h"
#include "3dlib/Attributes/texture.h"
#include "m_matv.h"
#include "previewer.h"



MEMaterialViewport::MEMaterialViewport( int i, MEPreviewRenderer *rend,
					QWidget *parent ) :
  QLabel( parent ), pixmap_(60, 60, -1)
{
  previewer_ = rend;
  num_       = i;
  material_  = new G3DAColor;
  setFrameStyle ( Panel | Sunken );
  setLineWidth (2);

  previewer_->renderPixmapWith (material_); // not sure !

  bitBlt (&pixmap_, 0, 0, previewer_->getPixmap(), 0, 0, -1, -1, 
	  CopyROP, TRUE);
  setPixmap (pixmap_);
}

MEMaterialViewport::~MEMaterialViewport ()
{
  delete material_;
}


const G3DATexture*
MEMaterialViewport::getMaterial () const
{
  if (material_ == 0)
    cout << "MMaterialViewport::getMaterial: returning 0 material!" << endl;

  return material_;
}

void
MEMaterialViewport::mouseReleaseEvent( QMouseEvent* )
{
  emit activated (num_);
}

void
MEMaterialViewport::resizeEvent ( QResizeEvent* )
{
  cout << "matv res: " << width() << endl;
}

void
MEMaterialViewport::setMaterial ( const G3DATexture *mat )
{
  delete material_;
  material_ = (G3DATexture*)(mat->copy());
  previewer_->renderPixmapWith (material_);
  bitBlt(&pixmap_, 0, 0, previewer_->getPixmap(), 0, 0, -1, -1,
         CopyROP, TRUE);
  setPixmap (pixmap_);
}


//====================================END====================================
