/*
 * Project : MindsEye, material editor
 * Copyright (c) 1996 - 1998
 * Author(s): M. van Velsen, M. Kuball
 * 
 * $Id: m_matv.h,v 1.2 2000/02/29 20:31:17 ainvar Exp $
 * 
 * 
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 * OVERVIEW
 * ========
 *
 */

#ifndef __MMATERIAL_VIEWPORT_H__
#define __MMATERIAL_VIEWPORT_H__

#include "qlabel.h"
#include "qpixmap.h"

class G3DATexture;
class MEPreviewRenderer;



/**Preview the choosen material.
 */
class MEMaterialViewport : public QLabel
{
   Q_OBJECT

public:
   MEMaterialViewport ( int, MEPreviewRenderer*, QWidget *parent=0 );
   ~MEMaterialViewport ();
   
   const G3DATexture* getMaterial () const;
   void setMaterial ( const G3DATexture* );

signals:
     ///num_ is used as parameter.
   void activated ( int );

protected:
   void mouseReleaseEvent ( QMouseEvent* );
   void resizeEvent ( QResizeEvent* );

protected:
   MEPreviewRenderer *previewer_;
   QPixmap           pixmap_;

   int         num_;
   G3DATexture *material_;
};


#endif
