/**********************************************************************

	--- Qt Architect generated file ---

	File: matw_uni.cpp
	Last generated: Tue Jun 9 14:13:02 1998

 *********************************************************************/

#include "include/config.h"
#include "matw_generic.h"
#include "3dlib/t_fields.h"
#include <qcolordialog.h>

#define Inherited MEMatWidgetGenericData

static void setColor ( G3DColor &mcol, QColor &col, QWidget *widget );

void
setColor ( G3DColor &mcol, QColor &col, QWidget *widget )
{
  col.setRgb (mcol.red(), mcol.green(), mcol.blue());
  
  QColor newColor = QColorDialog::getColor (col, 0, "");
  
  if (newColor.isValid()) {
    widget->setPalette (QPalette(newColor));
    mcol.setTo (newColor.red(), newColor.green(), newColor.blue());
  }
  else {
    widget->setPalette (QPalette(col));
  }
}


MEMatWidgetGeneric::MEMatWidgetGeneric
(
	QWidget* parent,
	const char* name
)
	:
	Inherited( parent, name )
{
  setFrameStyle( WinPanel | Sunken );
  trackDiffuse_ = true;
  connect( parent, SIGNAL(materialChanged(const G3DATexture*)),
	   SLOT(setMaterial(const G3DATexture*)) );
  initWidget();
}


MEMatWidgetGeneric::~MEMatWidgetGeneric ()
{
}


const char*
MEMatWidgetGeneric::GetAttributeType ()
{
  return (G3DAColor::GetTypeName());
}

const char*
MEMatWidgetGeneric::GetDescription ()
{
  return "generic Material";
}

void
MEMatWidgetGeneric::initWidget ()
{
  Param  params[5];
  QColor   col;
  G3DColor *mcol;

  material_.getParameter( params );
  mcol = params[0].color;
  col.setRgb( mcol->red(), mcol->green(), mcol->blue() );
  ambient_->setPalette( QPalette(col) );
  mcol = params[1].color;
  col.setRgb( mcol->red(), mcol->green(), mcol->blue() );
  diffuse_->setPalette( QPalette(col) );
  mcol = params[2].color;
  col.setRgb( mcol->red(), mcol->green(), mcol->blue() );
  specular_->setPalette( QPalette(col) );
}

void
MEMatWidgetGeneric::setAmbient ()
{
  G3DColor mcol;
  QColor   col;
  
  material_.getAmbientColor (mcol);
  setColor (mcol, col, ambient_);
  material_.setAmbientColor (mcol);
  emit changed (&material_);
}

void
MEMatWidgetGeneric::setDiffuse()
{
  G3DColor mcol;
  QColor   col;
  
  material_.getDiffuseColor(mcol);
  setColor (mcol, col, diffuse_);
  material_.setDiffuseColor (mcol);
  if (trackDiffuse_) {	
    specular_->setPalette (QPalette(col));
    material_.setSpecularColor (mcol);
  }
  emit changed( &material_ );
}

void
MEMatWidgetGeneric::setMaterial ( const G3DATexture *mat )
{
  material_.setValues( mat );
  initWidget();
}

void
MEMatWidgetGeneric::setShininess ()
{
  QString str = shininess_->text();
  float sh = str.toFloat();
  if( sh < 0.0 )
    sh = 0;
  else if( sh > 128.0 )
    sh = 128.0;
  str.setNum( sh );
  shininess_->setText( str );
  material_.setShininess( sh );

  emit changed( &material_ );
}

void
MEMatWidgetGeneric::setSpecular ()
{
  G3DColor mcol;
  QColor   col;
  material_.getSpecularColor( mcol );
  setColor( mcol, col, specular_ );
  material_.setSpecularColor( mcol );
  emit changed( &material_ );
}

void
MEMatWidgetGeneric::trackDiffuse ( bool val )
{
  trackDiffuse_ = val;
  if (val) {
    const QColor &col = diffuse_->backgroundColor();
    specular_->setPalette( QPalette(col) );
    G3DColor mcol( col.red(), col.green(), col.blue() );
    material_.setSpecularColor( mcol );
  }
}


//==================================END================================
