/**********************************************************************

	--- Qt Architect generated file ---

	File: matw_mtl.cpp
	Last generated: Mon Aug 17 17:08:20 1998

 *********************************************************************/

#include "matw_mtl.h"
#include "3dlib/t_fields.h"
// #include "dialogs/color/colorpicker.h"
#include <qcolordialog.h>

#define Inherited MEMatWidgetMetalData

static const char* MetalNames[] =
{ "Brass", "Bronze", "Chrome 1",
  "Chrome 2", "Copper",
  "Gold", "Silver", "Steel", NULL
};

#define rgb(r,g,b) {int(r*255), int(g*255), int(b*255)}
static const int MetalColors[][3] =
{ rgb(0.58, 0.42, 0.20), rgb(0.4, 0.2, 0.15), rgb(0.2, 0.2, 0.2),
  rgb(0.5, 0.5, 0.5), rgb(0.6, 0.3, 0.15),
  rgb(0.65, 0.35, 0.15), rgb(0.94, 0.93, 0.9), rgb(0.39, 0.41, 0.43)
};

static const float Roughness[] =
{ 1.0/60, 1.0/80, 1.0/100,
  1.0/120, 1.0/80,
  1.0/100, 1.0/80, 1.0/20
};



MEMatWidgetMetal::MEMatWidgetMetal( QWidget* parent, const char* name ) :
  Inherited( parent, name )
{
  setFrameStyle( WinPanel | Sunken );
  metalName_->insertStrList( MetalNames );
  connect( parent, SIGNAL(materialChanged(const G3DATexture*)),
	   SLOT(setMaterial(const G3DATexture*)) );
  chooseMetal( 0 );
}

MEMatWidgetMetal::~MEMatWidgetMetal()
{
}


void
MEMatWidgetMetal::chooseMetal( int id )
{
  QColor col( MetalColors[id][0], MetalColors[id][1], MetalColors[id][2] );
  diffuse_->setPalette( QPalette(col) );
  G3DColor mcol( MetalColors[id][0], MetalColors[id][1], MetalColors[id][2] );
  material_.setDiffuseColor( mcol );

  QString str;
  str.setNum( Roughness[id] );
  roughness_->setText( str );
  material_.setRoughness( Roughness[id] );

  emit changed( &material_ );
}

const char*
MEMatWidgetMetal::GetAttributeType ()
{
  return( G3DAMetal::GetTypeName() );
}

const char*
MEMatWidgetMetal::GetDescription ()
{
  return( "Metal" );
}

void
MEMatWidgetMetal::setAmbient ()
{
  QColor newColor = QColorDialog::getColor (white);
  
  if (newColor.isValid()) {
    ambient_->setPalette (QPalette(newColor));
    G3DColor mcol (newColor.red(), newColor.green(), newColor.blue());
    material_.setAmbientColor (mcol);
  }
  else {
    ambient_->setPalette (QPalette(white));
    G3DColor mcol (white.red(), white.green(), white.blue());
    material_.setAmbientColor (mcol);
  }

  emit changed( &material_ );
}

void
MEMatWidgetMetal::setDiffuse ()
{  
  QColor newColor = QColorDialog::getColor (white);
  
  if (newColor.isValid()) {
    diffuse_->setPalette (QPalette(newColor));
    G3DColor mcol (newColor.red(), newColor.green(), newColor.blue());
    material_.setDiffuseColor (mcol);
  }
  else {
    diffuse_->setPalette (QPalette(white));
    G3DColor mcol (white.red(), white.green(), white.blue());
    material_.setDiffuseColor (mcol);
  }

  emit changed (&material_);
}

void
MEMatWidgetMetal::setRoughness()
{
  QString str = roughness_->text();
  float   rg  = str.toFloat();

  if( rg < 0.00001 )
    rg = 0.00001;
  else if( rg > 1.0 )
    rg = 1.0;
  str.setNum( rg );
  roughness_->setText( str );
  material_.setRoughness( rg );

  emit changed( &material_ );
}

void
MEMatWidgetMetal::setSpecRef()
{
  QString str = specRef_->text();
  float   sp  = str.toFloat();

  if( sp < 0 )
    sp = 0;
  else if( sp > 1.0 )
    sp = 1.0;
  str.setNum( sp );
  specRef_->setText( str );
  material_.setSpecRef( sp );

  emit changed( &material_ );
}

void
MEMatWidgetMetal::setMirrorEffect()
{
  QString str = mirrorEffect_->text();
  float   me  = str.toFloat();

  if( me < 0 )
    me = 0;
  else if( me > 1.0 )
    me = 1.0;
  str.setNum( me );
  mirrorEffect_->setText( str );
  material_.setMirrorEffect( me );

  emit changed( &material_ );
}

void
MEMatWidgetMetal::setMaterial( const G3DATexture *mat )
{
  if( mat->getType() == TA_METAL )
    {
      material_.setValues( mat );
      //TODO save metal type in attribute?
      Param  params[5];
      QColor   col;
      G3DColor *mcol;

      material_.getParameter( params );
      mcol = params[0].color;
      col.setRgb( mcol->red(), mcol->green(), mcol->blue() );
      ambient_->setPalette( QPalette(col) );
      mcol = params[1].color;
      col.setRgb( mcol->red(), mcol->green(), mcol->blue() );
      diffuse_->setPalette( QPalette(col) );

      QString str;
      str.setNum( params[2].flt );
      specRef_->setText( str );
      str.setNum( params[3].flt );
      roughness_->setText( str );
      str.setNum( params[4].flt );
      mirrorEffect_->setText( str );
    }
}


//==================================END================================
