/**********************************************************************

	--- Qt Architect generated file ---

	File: matw_mtl.cpp
	Last generated: Mon Aug 17 17:08:20 1998

 *********************************************************************/

#include "matw_plastic.h"
#include "3dlib/t_fields.h"
// #include "dialogs/color/colorpicker.h"
#include <qcolordialog.h>

#define Inherited MEMatWidgetPlasticData


MEMatWidgetPlastic::MEMatWidgetPlastic( QWidget* parent, const char* name ) :
  Inherited( parent, name )
{
  setFrameStyle( WinPanel | Sunken );
  connect( parent, SIGNAL(materialChanged(const G3DATexture*)),
	   SLOT(setMaterial(const G3DATexture*)) );
}

MEMatWidgetPlastic::~MEMatWidgetPlastic()
{
}


const char*
MEMatWidgetPlastic::GetAttributeType ()
{
  return( G3DAPlastic::GetTypeName() );
}

const char*
MEMatWidgetPlastic::GetDescription ()
{
  return "Plastic";
}

void
MEMatWidgetPlastic::setAmbient ()
{
  QColor newColor = QColorDialog::getColor (white);
  
  if (newColor.isValid()) {
    ambient_->setPalette (QPalette(newColor));
    G3DColor mcol (newColor.red(), newColor.green(), newColor.blue());
    material_.setAmbientColor (mcol);
  }
  else {
    ambient_->setPalette (QPalette(white));
    G3DColor mcol (white.red(), white.green(), white.blue());
    material_.setAmbientColor (mcol);
  }

  emit changed( &material_ );
}

void
MEMatWidgetPlastic::setDiffuse ()
{
  QColor newColor = QColorDialog::getColor (white);
  
  if (newColor.isValid()) {
    diffuse_->setPalette (QPalette(newColor));
    G3DColor mcol (newColor.red(), newColor.green(), newColor.blue());
    material_.setDiffuseColor (mcol);
    if (trackDiffuse_) {
      ambient_->setPalette (QPalette(newColor));
      material_.setAmbientColor (mcol);
    }
  }
  else {
    diffuse_->setPalette (QPalette(white));
    G3DColor mcol (white.red(), white.green(), white.blue());
    material_.setDiffuseColor (mcol);
    if (trackDiffuse_) {
      ambient_->setPalette (QPalette(white));
      material_.setAmbientColor (mcol);
    }
  }

  emit changed (&material_);
}

void
MEMatWidgetPlastic::setMaterial( const G3DATexture *mat )
{
  if( mat->getType() == TA_PLASTIC )
    {
      material_.setValues( mat );
      Param  params[5];
      QColor   col;
      G3DColor *mcol;

      material_.getParameter( params );
      mcol = params[0].color;
      col.setRgb( mcol->red(), mcol->green(), mcol->blue() );
      ambient_->setPalette( QPalette(col) );
      mcol = params[1].color;
      col.setRgb( mcol->red(), mcol->green(), mcol->blue() );
      diffuse_->setPalette( QPalette(col) );

      QString str;
      str.setNum( params[2].flt );
      specRef_->setText( str );
      str.setNum( params[3].flt );
      roughness_->setText( str );
      str.setNum( params[4].flt );
      mirrorEffect_->setText( str );
    }
}

void
MEMatWidgetPlastic::setMirrorEffect()
{
  QString str = mirrorEffect_->text();
  float   me  = str.toFloat();

  if( me < 0 )
    me = 0;
  else if( me > 1.0 )
    me = 1.0;
  str.setNum( me );
  mirrorEffect_->setText( str );
  material_.setMirrorEffect( me );

  emit changed( &material_ );
}

void
MEMatWidgetPlastic::setRoughness()
{
  QString str = roughness_->text();
  float   rg  = str.toFloat();

  if (rg < 0.00001)
    rg = 0.00001;
  else if (rg > 1.0)
    rg = 1.0;
  str.setNum (rg);
  roughness_->setText (str);
  material_.setRoughness (rg);
  
  emit changed (&material_);
}

void
MEMatWidgetPlastic::setSpecRef ()
{
  QString str = specRef_->text();
  float   sp  = str.toFloat();

  if (sp < 0)
    sp = 0;
  else if (sp > 1.0)
    sp = 1.0;
  str.setNum (sp);
  specRef_->setText (str);
  material_.setSpecRef (sp);

  emit changed (&material_);
}

void
MEMatWidgetPlastic::trackingChanged ( bool val )
{
  trackDiffuse_ = val;
  if (val) {
    const QColor &col = diffuse_->backgroundColor();
    ambient_->setPalette( QPalette(col) );
    G3DColor mcol( col.red(), col.green(), col.blue() );
    material_.setAmbientColor (mcol);
  }
}

//==================================END================================
