/*
 * Project : "MindsEye"
 * Copyright  1998. All Rights Reserved.
 * Author(s): M. Kuball
 *
 * $Id: qglpix.h,v 1.2 2000/02/29 20:31:17 ainvar Exp $
 *
 *
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 * OVERVIEW
 * ========
 *
 */

#ifndef _QGL_PIXMAP_H
#define _QGL_PIXMAP_H

#include <qpixmap.h>


/**This class provieds an off-screen OpenGL render buffer.
   no double Buffering is supported.
   */
class QGLPixmap : public QPixmap
{
    //Q_OBJECT

public:
    QGLPixmap ( int w, int h, QPaintDevice* );
    virtual ~QGLPixmap ();
    void makeCurrent ();

protected:
    bool  chooseContext ();
    void* chooseVisual ();

private:	// Disabled copy constructor and operator=
    QGLPixmap( const QGLPixmap& ) {}
    QGLPixmap &operator=( const QGLPixmap & ) { return *this; }

protected:
    QPaintDevice *paintDevice;
    void         *pixmap_;
    void         *vi;
    void         *cx;
    bool         valid;
};


#endif
