/*
 * Project : "MindsEye, NURBS editor"
 * Copyright 1996, 1997. All Rights Reserved.
 * Author(s): P. Lavoie, M. Kuball
 *
 * $Id: attrib_widget.h,v 1.2 2002/06/16 20:50:39 ainvar Exp $
 *
 *
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef _ATTRIBUTE_WIDGET_H_
#define _ATTRIBUTE_WIDGET_H_

//#include <qwidget.h>
#include "tabwidget.h"
#include <vector>

class MModeler;
class QListBox;
class ToolboxWidget;
class QListViewItem;
class QPushButton;
class G3DAttribute;
class G3DObject;
class G3DSceneElement;
class MEPaletteFrame;
class MEAttributeItem;
class MEListView;


/**
 */
class MEAttributeWidget : public MeTabChild //QWidget
{
  Q_OBJECT

public:
  MEAttributeWidget( MModeler*, QWidget *parent=NULL );

signals:
  void setPageSize(int);

protected:
  void insertListItem( G3DAttribute* );
  void keyPressEvent( QKeyEvent* );
  void makeRootItems ();
  void resizeEvent(QResizeEvent*);

protected slots:
  void addAttribute();
  void relayout();
  void removeAttribute();
  void setCurrent( QListViewItem* );
  void setObject( G3DObject* );
  void setWorld( QObject* );
  void updateView();

private:
  QListBox      *attribTypes_;
  MEListView     *attribView_;
  QListViewItem *listRoot1_, *listRoot2_, *listRoot3_, *listRoot4_;
  QPushButton   *addButton_;

  int            yWidgets_;
  vector<void*>  widgets_;

  MModeler        *model_;
  QObject         *world_;
  G3DSceneElement *object_;
  MEAttributeItem *currentItem_;
};


#endif
