/*
 * Project : "MindsEye, NURBS editor"
 * Copyright 1996, 1997. All Rights Reserved.
 * Author(s): P. Lavoie, M. Kuball
 *
 * $Id: cameraPool.h,v 1.2 2000/02/11 22:41:11 ainvar Exp $
 *
 *
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef _CAMERA_POOL_H_
#define _CAMERA_POOL_H_

#include "paletteFrame.h"

class G3DCamera;
class QComboBox;


/**This info widgets allows the user to manage the list of cameras in
   a world: select a camera, add a new camera or remove a camera.
   An existing camera may be set to the orientation of the camera in the
   active viewport.
 */
class MECameraPool : public MEPaletteFrame
{
  Q_OBJECT

public:
  MECameraPool( QObject*, QWidget *parent=NULL );

protected:
  void resizeEvent(QResizeEvent*);

protected slots:
  void addCamera ();
  void cameraSelected (int);
  void cameraSelected (const QString&);
  void deleteCamera ();
  void setCamera (G3DCamera*);
  void setCameraList ();
  virtual void setWorld (QObject*);
  virtual void updateView ();

protected:
  QComboBox  *names_;
  G3DCamera  *camera_;
};

#endif
