/*
 * Project : "MindsEye, NURBS editor"
 * Copyright 1996, 1997. All Rights Reserved.
 * Author(s): P. Lavoie, M. Kuball
 *
 * $Id: create_widget.h,v 1.1.1.1 1999/09/09 23:57:35 iamcliff Exp $
 *
 *
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef _CREATE_WIDGET_H_
#define _CREATE_WIDGET_H_

#include "include/config.h"
//#include <qwidget.h>
#include "tabwidget.h"

class MModeler;
class QComboBox;
class QListBox;
class ToolboxWidget;
class MENurbsTools;


/**
 */
class MECreateWidget: public MeTabChild
{
  Q_OBJECT

public:
  MECreateWidget( MModeler*, QWidget *parent=NULL );

signals:
  void setPageSize(int);

protected:
  void resizeEvent(QResizeEvent*);

protected slots:
  void relayout();
  void setWorkScale(MeFloat); 
    ///
  void useObjClass(int);
    ///
  void useObjType(int);

private:
  MModeler      *model_;
  QComboBox     *objClasses_;
  QListBox      *objTypes_;
  MENurbsTools  *nurbsFrame_;
  int           yWidgets_;

  int           typeNr_;
  MeFloat       workScale_;
};

#endif
