/*
 * Project : "MindsEye, NURBS editor"
 * Copyright 1996, 1997. All Rights Reserved.
 * Author(s): P. Lavoie, M. Kuball
 *
 * $Id: edit_widget.h,v 1.2 2002/06/16 20:50:39 ainvar Exp $
 *
 *
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef _EDIT_WIDGET_H_
#define _EDIT_WIDGET_H_

#include "include/config.h"
//#include <qwidget.h>
#include <vector>
#include "tabwidget.h"
//#include "3dlib/g3d_math.h"

class MEPaletteFrame;
class MEVectorEdit;
class MWorldObject;
class G3DObject;
class QLabel;
class QLineEdit;
class QPushButton;



/**This Widget is used to control the state of the modeler.
 */
class MEEditWidget : public MeTabChild //QWidget
{
  Q_OBJECT

public:
  MEEditWidget( QObject *model, QWidget *parent=NULL );

signals:
  void setPageSize(int);

protected:
  void deleteWidgets ();
  void resizeEvent( QResizeEvent* );

protected slots:
  void findObject();
  void relayout();
  void setObjectName();
  void setObject( G3DObject* );
  void setWorld( QObject* );
  void updateView();

private:
  int              yWidgets_;

  MWorldObject     *world_;
  G3DObject        *object_;
  QLineEdit        *name_;
  QLabel           *typeName_;
  QPushButton      *setBtn_, *findBtn_;

  vector<void*>    widgets_;
  MEPaletteFrame   *trafoFrame_;

};

#define GET_WIDGET(i) ((MEPaletteFrame*)(widgets_[i]))

#endif
