/*
 * Project : "MindsEye, NURBS editor"
 * Copyright 1996, 1997. All Rights Reserved.
 * Author(s): P. Lavoie, M. Kuball
 *
 * $Id: meshFrame.cpp,v 1.1.1.1 1999/09/09 23:57:42 iamcliff Exp $
 *
 *
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include "include/config.h"
//TODO #include <qframe.h>
#include <qlabel.h>
#include <qlined.h>
#include <qpushbutton.h>

#include "meshFrame.h"
#include "3dlib/object.h"
#include "kernel/world_obj.h"
#include "factories.h"
#include <vector>


void
createMeshWidget( vector<void*> *list, QWidget *p )
{
  list->push_back( (void*)(new MEMeshFrame(p)) );
}

//--------------------------------------------------------------------


MEMeshFrame::MEMeshFrame( QWidget *p ) :
  MEPaletteFrame( "Mesh Parameter", NULL, p)
{
  int y = tSize;

  //switch normals
  //inside, outside, both sides
  //list of vertices
  //smooth/flat
  //
  QPushButton *btn = new QPushButton( "inside out", this );
    btn->setGeometry( 2, y, 60, 18 );
    connect( btn, SIGNAL(clicked()), SLOT(switchOrientation()) );
    y += 20;

  //QCheckBox *cbox = new QCheckBox( "smooth", this );
 
    /*
  QLabel *lb = new QLabel( "Height", this );
  lb->setGeometry( 2, y, 75, 20 );
  height_ = new QLineEdit( this );
  height_->move( 78, y );
  y += 20;

  lb = new QLabel( "Major radius", this );
  lb->setGeometry( 2, y, 75, 20 );
  radius1_ = new QLineEdit( this );
  radius1_->move( 78, y );
  y += 20;

  lb = new QLabel( "Minor radius", this );
  lb->setGeometry( 2, y, 75, 20 );
  radius2_ = new QLineEdit( this );
  radius2_->move( 78, y );
  y += 20;

  QPushButton *btn = new QPushButton( "set", this );
    btn->setGeometry(2, y, 40, 18 );
    connect( btn, SIGNAL(clicked()), SLOT(applyValues()) );
    y += 20;
    */
  visHeight_ = y;
  resize( 100, y );
}

void
MEMeshFrame::applyValues( )
{
  /*
  Param params[4];
  const char *str;
  MeFloat l;

  object_->getParameter( params );

  str = height_->text();
  l   = atof( str );
  if( l < 0 )
    l = 0;
  (params->vector3)->normalize();
  *(params->vector3) *= l;

  str = radius1_->text();
  l   = atof( str );
  if( l < 0 )
    l = 0;
  params[1].flt = l;

  str = radius2_->text();
  l   = atof( str );
  if( l < 0 )
    l = 0;
  params[2].flt = l;

  object_->setParameter( params );
  object_->adjust();
  if( world_ != NULL )
    ((MWorldObject*)world_)->update();
    */
}

void
MEMeshFrame::resizeEvent( QResizeEvent *e )
{
  MEPaletteFrame::resizeEvent( e );
  /*
  height_->resize( width()-80, 20 );
  radius1_->resize( width()-80, 20 );
  radius2_->resize( width()-80, 20 );
  */
}

void
MEMeshFrame::setObject( G3DObject *obj )
{
  object_ = obj;
  updateView();
}

void
MEMeshFrame::switchOrientation()
{
}

void
MEMeshFrame::updateView()
{
  /*
  if( object_ )
    {
      QString str;
      Param params[4];
      object_->getParameter( params );

      MeFloat l = (params->vector3)->length();
      str.setNum( l, 'g', 4 );
      height_->setText( str );
      
      str.setNum( params[1].flt, 'g', 4 );
      radius1_->setText( str );
      
      str.setNum( params[2].flt, 'g', 4 );
      radius2_->setText( str );
    }
  else
    {
      height_->setText( "" );
      radius1_->setText( "" );
      radius2_->setText( "" );
    }
    */
}


//=================================END====================================
