/*
 * Project : "MindsEye, NURBS editor"
 * Copyright 1996, 1997. All Rights Reserved.
 * Author(s): P. Lavoie, M. Kuball
 *
 * $Id: nurbsFrame.h,v 1.1.1.1 1999/09/09 23:57:50 iamcliff Exp $
 *
 *
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef _TOOLBOX_H_
#define _TOOLBOX_H_

#include "paletteFrame.h"

class QGroupBox;
class QButtonGroup;
class G3DNurbs;
class QBoxLayout;
class CurveInterpWidget;
class SkinSurfWidget;
class SurfOfRevWidget;
class SweptSurfWidget;
class ExtrudeSurfWidget;
class QLabel;
class MModeler;


/**
 */
class MENurbsTools: public MEPaletteFrame
{
  Q_OBJECT

public:
  MENurbsTools( QObject *model, QWidget *parent=0 );
  ~MENurbsTools();

  //int load(const char* filename) ;
  //int save(const char* filename, int saveMode) ;

public slots:
  void viewMode( int );
  void editMode( int );
  void affectMode( int );
  void selectMode(int) ;
  void genSurf(int) ;
 // void genCurve(int) ;
  void knotOp(int) ;
  void drawCurve() ;
  void setSurfaceView(int) ;
  void preferenceWindow() ;

  //void setU(float) ;
  //void setV(float) ;
  //void paramOp(int) ;
  //void adjustEditBtn(NurbsEditMode mode) ;
  //void setUV(float,float) ;

//public:
  //NurbsObjectWidget *nurbsO ;

signals:
  void  info();

protected:
  void makeBtnGroup( QButtonGroup *btnGroup, int num, char **names );


private:
//TODO do we need these variables?
  QButtonGroup *genSurfGroup, *genCurveGroup, *selectGroup, *knotGroup;
  QButtonGroup *viewGroup, *editGroup, *affectGroup, *paramGroup;

  CurveInterpWidget    *interpWindow;
  SkinSurfWidget       *skinS;
  SurfOfRevWidget      *surfOfR;
  SweptSurfWidget      *sweepS ;
  ExtrudeSurfWidget    *extrudeS ;

  MModeler    *_model;
  /*
  //PreferenceWidget *prefW ;
  //SetParamWidget *setParam ;

  QLabel *uLabel, *vLabel ;
  float paramU,paramV ;
  int   useU, useV ;
  */
};

#endif _TOOLBOX_H_
