/*
 * Project : "MindsEye, NURBS editor"
 * Copyright 1996, 1997. All Rights Reserved.
 * Author(s): P. Lavoie, M. Kuball
 *
 * $Id: paletteFrame.cpp,v 1.2 2001/07/15 20:56:27 ainvar Exp $
 *
 *
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include "include/config.h"
#include <qlabel.h>
#include <qpushbt.h>
#include "paletteFrame.h"

int MEPaletteFrame::tSize = 19;  //Height of title


MEPaletteFrame::MEPaletteFrame ( const char *cp, QObject* model, QWidget *p ) :
  QFrame(p)
{
/*
if (floating_ )
{
  recreate (NULL, 0, QPoint(100,100), TRUE);
}
*/
  setFrameStyle (Panel | Plain);
  visible_ = true;
  capLabel_ = new QLabel (cp, this);
    capLabel_->move (0, 0);
    capLabel_->setFrameStyle (WinPanel | Raised);
    capLabel_->setPalette (darkGray);
  capButton_ = new QPushButton ("-", this);
    capButton_->resize (tSize, tSize);
    capButton_->setPalette (darkGray);
    connect (capButton_, SIGNAL(clicked()), SLOT(toggle()));

  world_ = NULL;
  if (model)
    connect (model, SIGNAL(worldChanged(QObject*)), SLOT(setWorld(QObject*)));
}

void
MEPaletteFrame::resizeEvent ( QResizeEvent* )
{
  capLabel_->resize (width()-tSize, tSize);
  capButton_->move (width()-tSize, 0);
}

void
MEPaletteFrame::setObject ( G3DObject* )
{
}

void
MEPaletteFrame::setWorld ( QObject *obj )
{
  if (world_)
    world_->disconnect (this);
  world_  = obj;

  connect (world_, SIGNAL(objectChanged()), SLOT(updateView()));
}

void
MEPaletteFrame::toggle ()
{
  if (visible_){
    resize (width(), tSize);
    capButton_->setText ("+");
    visible_ = false;
  }
  else {
    resize (width(), visHeight_);
    capButton_->setText ("-");
    visible_ = true;
  }
  emit sizeChanged ();
}
