/*
 * Project : "MindsEye"
 * Copyright (c) 1996 - 1998. All Rights Reserved.
 * Author(s) M. Kuball
 *
 * $Id: sceneInfo.h,v 1.1.1.1 1999/09/09 23:57:56 iamcliff Exp $
 * 
 * 
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 * OVERVIEW
 * ========
 *
 */

#ifndef __SCENE_FRAME_H__
#define __SCENE_FRAME_H__

#include "include/config.h"
#include "paletteFrame.h"
#include "3dlib/Attributes/color.h"

class G3DObject;
class QMultiLineEdit;
class QPushButton;


/**
 */
class MESceneInfo : public MEPaletteFrame
{
  Q_OBJECT

public:
  MESceneInfo( QWidget *parent=NULL );

public slots:
  virtual void setObject( G3DObject* );

protected:
  void resizeEvent(QResizeEvent*);

protected slots:
  void    applyValues();
  void    setBgColor();
  virtual void updateView();

protected:
  QPushButton    *colButton_;
  QMultiLineEdit *infoEditor_;
  G3DColor       bgColor_;
  G3DObject      *scene_;

};


#endif
