/*
 * Project : "MindsEye"
 * Copyright (c) 1998. All Rights Reserved.
 * Author(s):   Philippe Lavoie, Martin Kuball
 * 
 * $Id: tabwidget.h,v 1.3 2002/06/16 20:50:39 ainvar Exp $
 *
 *
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef _ptabwidget_h
#define _ptabwidget_h

#include <qwidget.h>
#include <list>

class QScrollBar;
class QTabBar;

/*
typedef struct
{
  QWidget *w; 
  int     id;
  int     pos;    //y-Pos of the widget relative to its parent
  int     psize;  //The virtual hight of the widget (include invisible parts)
  int     mode;   //assigned by the modeler to keep track of the edit mode
}  WidgetId;

inline int operator==(const WidgetId& a, const WidgetId& b)
{
  return (a.id == b.id) && (a.w == b.w) ; 
}

inline int operator<(const WidgetId& a, const WidgetId& b)
{
  return a.id < b.id ; 
}

inline int operator>(const WidgetId& a, const WidgetId& b)
{
  return a.id > b.id ; 
}
*/

/**
 */
class MeTabChild : public QWidget
{
  friend class MeTabWidget;

  Q_OBJECT

public:
  MeTabChild( QWidget* p );

protected:
  int     id_;
  int     pos_;    //y-Pos of the widget relative to its parent
  int     psize_;  //The virtual hight of the widget (include invisible parts)
  int     mode_;   //assigned by the modeler to keep track of the edit mode
};


/**A Abulator Widget without "OK" and "Cancel" buttons.
 */
class MeTabWidget : public QWidget
{
  Q_OBJECT

public:
  MeTabWidget( QWidget *parent=0, const char *name=0 );

  int  addTab( int, MeTabChild*, const QString& );
  int  current () const ; 
  //void setCurrent( int ); 
  virtual void show(); 

signals:
  void selected(int) ; 

protected slots:
  void scroll(int);
  void showPage(int) ; 
  //void setPageSize(int);

protected:
  virtual void resizeEvent( QResizeEvent* );
  virtual void paintEvent( QPaintEvent* ); 
  void    setScroller ();

protected:
  QTabBar    *tab_;
  QScrollBar *scroller_;
  //WidgetId   widgets_[4];  //TODO
  MeTabChild *widgets_[4];
  int        size_, scrollerWidth_;

};

#endif
