/*
 * Project : "MindsEye, NURBS editor"
 * Copyright 1996, 1997. All Rights Reserved.
 * Author(s): P. Lavoie, M. Kuball
 *
 * $Id: trafoFrame.h,v 1.1.1.1 1999/09/09 23:58:10 iamcliff Exp $
 *
 *
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef _TRAFO_FRAME_H_
#define _TRAFO_FRAME_H_

#include "paletteFrame.h"

class MEVectorEdit;
class G3DObject;
class QComboBox;


/**This widget is used to display the transformation paramter of an object.
   These are: scale, orientation, pivot point and position of the origin of
   the local coordinate system in the parent's coordinate system.
 */
class METrafoFrame : public MEPaletteFrame
{
  Q_OBJECT

public:
  METrafoFrame( QObject*, QWidget *parent=NULL );

public slots:
  virtual void setObject( G3DObject* );
  virtual void setWorld( QObject* );

protected:
  void resizeEvent(QResizeEvent*);

protected slots:
  void    applyValues();
  void    setPivotType(int);
  virtual void updateView();

protected:
  MEVectorEdit *scale_, *rotation_, *position_, *pivot_;
  QComboBox    *cbPivot_;
  G3DObject    *object_;
  int          pivotType_;

};

#endif
