/*
 * Project : "MindsEye, NURBS editor"
 * Copyright 1996, 1997. All Rights Reserved.
 * Author(s): P. Lavoie, M. Kuball
 *
 * $Id: trigridFrame.cpp,v 1.1.1.1 1999/09/09 23:58:10 iamcliff Exp $
 *
 *
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include "include/config.h"
#include <qframe.h>
#include <qlabel.h>
#include <qlined.h>
#include <qpushbutton.h>

#include "trigridFrame.h"
#include "3dlib/object.h"
#include "kernel/world_obj.h"
#include "factories.h"
#include <vector>


void
createTrigridWidget( vector<void*> *list, QWidget *p )
{
  //TODO createShapeFrame( list, p );
  //createMaterialWidget( list, p );
  list->push_back( (void*)(new METrigridFrame(p)) );
}

//--------------------------------------------------------------------


METrigridFrame::METrigridFrame( QWidget *p ) :
  MEPaletteFrame( "Trigrid Parameter", NULL, p)
{
  int y = tSize;

  QLabel *lb = new QLabel( "Rows", this );
    lb->setGeometry( 2, y, 60, 20 );
    nRows_ = new QLineEdit( this );
    nRows_->setGeometry( 60, y, 20, 20 );
    y += 20;

  lb = new QLabel( "Columns", this );
    lb->setGeometry( 2, y, 60, 20 );
    nColumns_ = new QLineEdit( this );
    nColumns_->setGeometry( 60, y, 20, 20 );
    y += 20;

  QPushButton *btn = new QPushButton( "set", this );
    btn->setGeometry(2, y, 100, 20 );
    connect( btn, SIGNAL(clicked()), SLOT(applyValues()) );
    y += 20;

  visHeight_ = y;
  resize( 100, y );
}

void
METrigridFrame::applyValues( )
{
  Param params[10];
  const char *str;

  object_->getParameter( params );

/*
  object_->setParameter( params );
  object_->adjust();
  if( world_ != NULL )
    ((MWorldObject*)world_)->update();
*/
}

void
METrigridFrame::resizeEvent( QResizeEvent *e )
{
  MEPaletteFrame::resizeEvent( e );
  nRows_->resize( width()-70, nRows_->height() );
  nColumns_->resize( width()-70, nColumns_->height() );
}

void
METrigridFrame::setObject( G3DObject *obj )
{
  object_ = obj;
  updateView();
}

void
METrigridFrame::updateView()
{
  if( object_ )
    {
      QString str;
      Param params[10];
      object_->getParameter( params );

      str.setNum( params[0].number );
      nRows_->setText( str );      
      str.setNum( params[1].number );
      nColumns_->setText( str );
    }
  else
    {
      nRows_->setText( "" );
      nColumns_->setText( "" );
    }
}


//=================================END====================================
