/*
 * Project : "MindsEye, 3D library"
 * Copyright (c) 1998. All Rights Reserved.
 * Author(s): Philippe Lovoie, M. Kuball
 *
 * $Id: view_widget.cpp,v 1.1.1.1 1999/09/09 23:58:10 iamcliff Exp $
 *
 *
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 */

#include "include/config.h"
#include "view_widget.h"
#include "aspectFrame.h"
#include "camCtrlFrame.h"
#include "cameraFrame.h"
#include "cameraPool.h"
#include <iostream>

MEViewWidget::MEViewWidget( QObject *modeler, QWidget *parent )
  : MeTabChild(parent) //QWidget(parent)
{
  cameraPool_ = new MECameraPool( modeler, this );
  connect( cameraPool_, SIGNAL(sizeChanged()), SLOT(relayout()) );

  camControler_ = new MECamCtrlFrame( modeler, this );
  connect( camControler_, SIGNAL(sizeChanged()), SLOT(relayout()) );

  cameraParams_ = new MECameraFrame( modeler, this );
  connect( cameraParams_, SIGNAL(sizeChanged()), SLOT(relayout()) );

  aspectFrame_  = new MEAspectFrame( modeler, this );
  connect( aspectFrame_, SIGNAL(sizeChanged()), SLOT(relayout()) );
}

void
MEViewWidget::relayout()
{
  resizeEvent( NULL );
}

void
MEViewWidget::resizeEvent( QResizeEvent* )
{
cout << "re view" << endl;
  int y = 2;
  cameraPool_->setGeometry( 0, y, width(), cameraPool_->height() );
  y += cameraPool_->height() + 2;
  camControler_->setGeometry( 0, y, width(), camControler_->height() );
  y += camControler_->height() + 2;
  cameraParams_->setGeometry( 0, y, width(), cameraParams_->height() );
  y += cameraParams_->height() + 2;
  aspectFrame_->setGeometry( 0, y, width(), aspectFrame_->height() );
  y += aspectFrame_->height();

  psize_ = y;
  //emit setPageSize( y );
} 


//====================================END================================
