/*
 * Project : "MindsEye, 3D library"
 * Copyright (c) 1998. All Rights Reserved.
 * Author(s): M. Kuball
 *
 * $Id: view_widget.h,v 1.1.1.1 1999/09/09 23:58:10 iamcliff Exp $
 *
 *
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 * OVERVIEW
 * ========
 *
 */

#ifndef _VIEW_WIDGET_H_
#define _VIEW_WIDGET_H_

//#include <qwidget.h>
#include "tabwidget.h"

class MEAspectFrame;
class MECameraFrame;
class MECameraPool;
class MECamCtrlFrame;


/**This widgets is the parent for all info widgets related to the cameras in
   a world.
 */
class MEViewWidget : public MeTabChild
{
  Q_OBJECT

public:
  MEViewWidget( QObject*, QWidget *parent=NULL );

signals:
  void setPageSize(int);

protected slots:
  void relayout();

protected:
  void resizeEvent( QResizeEvent* );

protected:
  MECamCtrlFrame *camControler_;
  MECameraFrame  *cameraParams_;
  MECameraPool   *cameraPool_;
  MEAspectFrame  *aspectFrame_;

};

#endif
