/*
 * Project : "MindsEye, NURBS editor"
 * Copyright 1996, 1997. All Rights Reserved.
 * Author(s): P. Lavoie
 *
 * $Id: SorWidget.h,v 1.3 2002/06/10 09:30:14 ainvar Exp $
 *
 *
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef _SOR_WIDGET_H_
#define _SOR_WIDGET_H_

#include "include/config.h"
#include <qwidget.h>
#include <nurbs++/specialType.h>

using PLib::Point3Df;

class AngleWidget;
class QLineEdit;
class MWorldObject;


/**This widget is used to set the parameter for a surface of revolution.
 */
class SurfOfRevWidget : public QWidget
{
  Q_OBJECT

public:
  SurfOfRevWidget( QWidget *parent=0, const char *name=0 );

  void show( MWorldObject* );

public slots:
  void changeAngle (MeFloat);
  void editAngle (/* const QString& */);
  void editSX (const QString&);
  void editSY (const QString&);
  void editSZ (const QString&);
  void editTX (const QString&);
  void editTY (const QString&);
  void editTZ (const QString&);
  void setRotationAxis (int);
  void sor () ;
  void hideWindow () ;

  //TODO remove this signals:
  //void genSOR(const Point3Df&, const Point3Df&, double);

protected:
    ///
  void createSurface (void);

protected:
  Point3Df S,T;
  int      axis_mode ;
  MeFloat  angle_;
  double   sx,sy,sz, tx,ty,tz;

  QLineEdit   *editA, *editSx, *editSy, *editSz;
  QLineEdit   *editTx, *editTy, *editTz;
  AngleWidget *aW;

  MWorldObject *_model;
};


#endif
