/*
 * Project : "MindsEye, 3D library"
 * Copyright (c) 1995 - 1997. All Rights Reserved.
 * Author(s): P. Lavoie, M. Kuball
 *
 * $Id: angleWidget.h,v 1.1.1.1 1999/09/09 23:58:33 iamcliff Exp $
 *
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 * OVERVIEW
 * ========
 *
 */

#ifndef _angle_widget_h_
#define _angle_widget_h_

#include "include/config.h"
#include <math.h>
#include <qwidget.h>
//#include "3dlib/g3d_math.h"

/**A widget used to select an angle.
 */
class AngleWidget: public QWidget
{
  Q_OBJECT

public:
  AngleWidget(QWidget *parent=0, const char *name=0) ;
  
  MeFloat angleDeg() const { return angle*180.0/M_PI; };
  MeFloat angleRad() const { return angle; };
  void    setRange( MeFloat as, MeFloat ae);

public slots:
  void setAngleDeg(MeFloat a);
  void setAngleRad(MeFloat a) ; 

signals:
  void angleChanged(MeFloat a) ; 

protected:
  void paintEvent(QPaintEvent *) ;
  void mouseMoveEvent ( QMouseEvent *) ;
  void mousePressEvent ( QMouseEvent *) ;
  //void resizeEvent( QResizeEvent * );

protected:
  MeFloat angle;  // = angleE - angleS
  MeFloat angleS, angleE;
};


#endif
