// occtestviewer.h
//
// (C) 2000  C R Johnson   iamcliff@ix.netcom.com
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU  General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//                                                                
// This software is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details. 
//                                      
// You should have received a copy of the GNU General Public License 
// along with this software (see COPYING); if not, write to the 
// Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef OCCTESTVIEWER_H
#define OCCTESTVIEWER_H

#include<qgl.h>
#include<Graphic3d_GraphicDevice.hxx>
#include<Xw_Window.hxx>
#include<V3d_View.hxx>
#include<AIS_InteractiveContext.hxx>


class OccTestViewer : public QGLWidget 
{ 
	Q_OBJECT

public:
	OccTestViewer(QWidget* parent, const char*);
	void InitOccTestViewer();

//	void initializeGL();
//	void paintGL () ;
//	void resizeGL(int w, int h);

	const Handle(Graphic3d_GraphicDevice)& GraphicDevice() const { return occTestDevice; } 
	const Handle(Xw_Window)& Window() const { return occTestWindow; }
	const Handle(V3d_View)& View() const { return occTestView; } 

	void SetView(const Handle(V3d_View)& aView);
	void SetContext(const Handle(AIS_InteractiveContext)& aContext);

protected:
	virtual void paintEvent ( QPaintEvent * );
	virtual void resizeEvent ( QResizeEvent * );
	//virtual void showEvent (QShowEvent *);
	virtual void mouseMoveEvent( QMouseEvent *);
	virtual void mousePressEvent( QMouseEvent *);
	virtual void mouseReleaseEvent( QMouseEvent *);
	virtual void keyPressEvent( QKeyEvent *);

private:
	Handle(Graphic3d_GraphicDevice) occTestDevice; 
	Handle(Xw_Window) occTestWindow; 
   Handle(V3d_View) occTestView;
	Handle(AIS_InteractiveContext)occTestContext;

	bool inViewManipulation;

	bool haveBox,haveTrihedron,haveSweep;

	Quantity_Factor speedFactor;
	Quantity_Factor zoomFactor;

	int lastx,lasty;	
	bool inMotion;

public slots:
	void Trihedron();
	void Box();
	void FitAll();
	void Evolve();
	void Shading();
	void Wire();
	void HLR();
};


#endif
