// occtestwidget.cpp

// (C) 2000  C R Johnson   iamcliff@ix.netcom.com
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU  General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//                                                                
// This software is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details. 
//                                      
// You should have received a copy of the GNU General Public License 
// along with this software (see COPYING); if not, write to the 
// Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "occtestwidget.h"
#include "occtestviewer.h"

#include <iostream.h>
#include <qpushbutton.h>
#include <qhbox.h>

#include <TCollection_ExtendedString.hxx>
#include <TCollection_AsciiString.hxx>
#include <V3d_OrthographicView.hxx>

void OccTestWidget::resizeEvent( QResizeEvent * qre)
{
	QSize occTestSize = qre->size();
	int width = occTestSize.width();
	int height = occTestSize.height();

	occTestViewer->setGeometry(0,25,width,height-25);
}

OccTestWidget::OccTestWidget( int module_id, int parent,  const char *name )
        : MEModule(module_id,parent,name)
{
	QHBox *hbox = new QHBox( this,"hbox");

	hbox->setGeometry(0,0,500,25);
	
   closeb = new QPushButton( "Close", hbox ,"closeb" );
   fun1 = new QPushButton( "CS", hbox, "fun1" );
   fun2 = new QPushButton( "Box", hbox, "fun2" );
   fun3 = new QPushButton( "FitAll", hbox, "fun3" );
	fun4 = new QPushButton( "Evolve", hbox, "fun4");
	fun5 = new QPushButton( "Shade", hbox, "fun5");
	fun6 = new QPushButton( "Wire", hbox, "fun6");
	fun7 = new QPushButton( "HLR", hbox, "fun7");

	occTestViewer = new OccTestViewer(this,"occTestViewer");
	occTestViewer->setGeometry(0,25,500,500);
	occTestViewer->InitOccTestViewer();

    connect( closeb, SIGNAL(clicked()), this, SLOT(close_me()) );
	 connect( fun1, SIGNAL(clicked()), occTestViewer, SLOT(Trihedron()));
	 connect( fun2, SIGNAL(clicked()), occTestViewer, SLOT(Box()));
	 connect( fun3, SIGNAL(clicked()), occTestViewer, SLOT(FitAll()));
	 connect( fun4, SIGNAL(clicked()), occTestViewer, SLOT(Evolve()));
	 connect( fun5, SIGNAL(clicked()), occTestViewer, SLOT(Shading()));
	 connect( fun6, SIGNAL(clicked()), occTestViewer, SLOT(Wire()));
	 connect( fun7, SIGNAL(clicked()), occTestViewer, SLOT(HLR()));
}
