/*
 * Project : "MindsEye, render queue"
 * Copyright (c) 1998. All Rights Reserved.
 * Author(s) M. Kuball
 *
 * $Id: bmrt_queue.h,v 1.2 2001/07/09 21:50:20 ainvar Exp $
 *
 *
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 * OVERVIEW
 * ========
 *
 */

#ifndef __BMRT_QUEUE_H_
#define __BMRT_QUEUE_H_

#include <stdlib.h>
#include "renderqueue.h"



/**Interface to BMRT (blue moon rendering tools).
  BMRT reads scenes in the RIB format.
 */
class MEBmrtQueue : public MERenderQueue
{
public:
  MEBmrtQueue () { command_ = NULL; }
  ~MEBmrtQueue ();

    ///Search for bmrt programm
  static  bool install ();
  virtual bool prepareJob ( MERenderJob* );
  virtual void renderFrame ( MERenderJob* );
  void    setCommand ( const char* );
  virtual void showOptionDialog ();


protected:
  char *command_;
};

#endif
