/*
 * Project : "MindsEye, render queue"
 * Copyright (c) 1998. All Rights Reserved.
 * Author(s) M. Kuball
 *
 * $Id: renderjob.h,v 1.2 2001/07/09 21:50:20 ainvar Exp $
 *
 *
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 * OVERVIEW
 * ========
 *
 */

#ifndef __RENDER_JOB_H_
#define __RENDER_JOB_H_

#include "smpte-time.h"

typedef unsigned int uint;

class MWorldObject;
class G3DCamera;
class G3DScene;


/**
 */
class MERenderJob
{
public:
  MERenderJob ();
  ~MERenderJob ();

  void  copyWorld ();
  int   getFrameRate () const { return fps_; }
  uint  getHeight () const { return h_; }
  const SmpteTime& getStartTime () const { return startTime_; }
  const SmpteTime& getStopTime () const { return stopTime_; }
  uint  getWidth () const { return w_; }
  G3DScene*     getScene ();
  MWorldObject* getWorld () { return( world_ ); }

  void setFrameRate ( const char* );  //TODO use int?
  void setTimeInterval ( const SmpteTime&, const SmpteTime& );
  void setOutput ( const char* format, const char *fname );
  void setResolution ( uint w, uint h );
  void setShutterTime ( float );
  void setWorld ( MWorldObject *wl );

protected:
  MWorldObject *world_;
  G3DCamera    *camera_;
  SmpteTime    startTime_, stopTime_;
  bool  worldIsCopy_;
  uint  w_, h_;
  int   fps_;
  char  *fname_;

  //vector<char*> options_;  //special optins
};

#endif
