/*
 * Project : "MindsEye, render queue"
 * Copyright (c) 1998. All Rights Reserved.
 * Author(s) M. Kuball
 *
 * $Id: smpte-time.cpp,v 1.2 2001/07/16 11:03:09 ainvar Exp $
 *
 *
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 * OVERVIEW
 * ========
 *
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "smpte-time.h"


SmpteTime::SmpteTime ( const char *buf, int fps )
{
  seconds_ = frames_ = 0;
  if (buf)
    {
      char *dbuf = new char[strlen(buf)+1];
      strcpy( dbuf, buf );
      char *pt1, *pt2;
      pt1 = pt2 = dbuf;
      int  vals[3], i = 0;

      do {
	if( *pt1 == ':' )
	  {
	    *pt1 = '\0';
	    vals[i++] = atoi( pt2 );
	    pt2 = pt1 + 1;
	  }
	else if( *pt1 == '\0' )
	  {
	    vals[i++] = atoi( pt2 );
	    break;
	  }
	++pt1;
      } while( i  < 3 );
      delete[] dbuf;

      int j = 0;
      if( i == 3 )
	{ seconds_ = 60 * vals[j++]; --i; }
      if( i == 2 )
	{ seconds_ += vals[j++]; --i; }
      frames_ = vals[j];
      if( frames_ >= fps )
	frames_ = fps;  //TODO
    }
}

void
SmpteTime::convert2char( char *buffer )
{
  int min = seconds_ / 60;
  int sec = seconds_ % 60;
  sprintf( buffer, "%i:%i:%i", min, sec, frames_ );
}

float
SmpteTime::convert2seconds( int fps ) const
{
  return( seconds_ + (frames_*(1.0/fps)) );
}

SmpteTime&
SmpteTime::operator=( const SmpteTime &orig )
{
  seconds_ = orig.seconds_;
  frames_  = orig.frames_;
}

bool
SmpteTime::operator!=( const SmpteTime &orig ) const
{
  return( (seconds_ != orig.seconds_) || (frames_ != orig.frames_) );
}

bool
SmpteTime::operator>( const SmpteTime &orig ) const
{
  if( seconds_ > orig.seconds_ )
    return true;
  if( seconds_ == orig.seconds_ && frames_ > orig.frames_ )
    return true;
  return false;
}


//====================================END===============================
