#ifndef LIGHT
#define LIGHT

#include "list.hh"
#include "vector.hh"
#include "rgb.hh"

class Light : public List
{
public:
  Light () { position = Vector(0,0,0), color = BLACK; }
  Light ( const Vector& pos, const rgb& col ) { position = pos, color = col; }
  
  void set_position ( const Vector& pos ) { position = pos; }
  void set_color ( const rgb& col ) { color = col; }
  
  const Vector& get_position () { return position; }
  const rgb& get_color () { return color; }
 
protected:
  Vector position;
  rgb color;

private:
};

#endif
