#include <iostream.h>

#include "object.hh"
#include "tplain.hh"

Object::Object ()
{
  lip = new Vector;
  texture=0;
}

Object::~Object ()
{
  delete lip;
}

Vector Object::intersection ( const Line& line ) const
{
  *lip = _intersection (line);
  return *lip;
}

Vector Object::_intersection ( const Line& line ) const
{
  // should not reach this
  return Z;
}

Surface Object::get_surface ()
{
  Surface retval;
  if (texture!=0) {
    retval=(*texture).get_surface((*lip));
  } else {
    TPlain temp;
    retval=temp.get_surface((*lip));
  }
  
  Vector norm=normal();
  norm.normalize();
  retval.normal=retval.normal+norm;
  
  return retval;
}

Vector Object::normal () const
{
  // should not reach this
  return Z;
}

bool Object::inside () const
{
  // should not reach this
  return false;
}
