#include "plane.hh"
#include <iostream.h>

Plane::Plane ()
{
  set_normal (Vector(0,1,0));
  set_offset (0);
  ins = new bool;
  *ins = false;
}

Plane::Plane ( const Vector& nor, double off )
{
  set_normal (nor);
  set_offset (off);
  ins = new bool;
  *ins = false;
}

Plane::~Plane ()
{
  delete ins;
}

//Algorithm by bineng
//coded by pauldoo
Vector Plane::_intersection ( const Line& l ) const
{
  //These #defines are to make the variables match those written down  :)
#define r l.get_start()
#define v l.get_direction()
#define n norm
#define d offset
 
  Vector retval;
  
  double nr=dot(n,r);
  
  *ins = ((nr-d)>0) ? false : true;
  
  double nv = dot (n, v);
  if (nv!=0) {
    
    double t=(d-nr)/nv;
    if (t>0) {
      retval=r+t*v;
    } else {
      retval.valid=false;
    }
  } else {
    retval.valid = false;
  }
  
#undef r
#undef v
#undef n
#undef d
  
  return retval;
}

Vector Plane::normal () const
{
  Vector retval = norm;
  if (*ins) {
    retval *= -1.0;
  }
  
  return retval;
}

bool Plane::inside () const
{
  return *ins;
}
