#include <stdlib.h>

#include "rgbbuffer.hh"

RGBBuffer::RGBBuffer ()
{
  width_ = height_ = 0;
  data_ = 0;
}

RGBBuffer::~RGBBuffer ()
{
  deallocate ();
}

void RGBBuffer::set_size ( uint new_width, uint new_height )
{
  width_ = new_width, height_ = new_height;
  allocate ();
}

void RGBBuffer::allocate ()
{
  if (data_) 
    delete data_;
  data_ = new uchar[width_*height_*3];
}

void RGBBuffer::deallocate ()
{
  delete data_;
  data_ = 0;
  width_ = height_ = 0;
}
