#ifndef RGBBUFFER
#define RGBBUFFER

#include <iostream.h>
#include "../kernel/types.hh"

/*
  TODO:
  - handle MSB correctly?
*/

class RGBBuffer
{
public:
  RGBBuffer ();
  ~RGBBuffer ();
  
  uchar *get_data () { return data_; }
  
  void set_size ( uint w, uint h );
  uint get_width () const { return width_; }
  uint get_height () const { return height_; }

  void allocate ();
  void deallocate ();
  
  uint get_pixel ( uint x, uint y ) const;
  void set_pixel ( uint x, uint y, uchar r, uchar g, uchar b );
  void set_pixel ( uint x, uint y, uint pixel );
 
private:
  uchar *data_;
  uint width_, height_;
};

inline void 
RGBBuffer::set_pixel ( uint x, uint y, uchar r, uchar g, uchar b )
{
  uchar * spot = data_ + (y * width_ + x)*3;
  *spot++ = r;
  *spot++ = g;
  *spot   = b; 
}

inline uint
RGBBuffer::get_pixel ( uint x, uint y ) const
{
  uint a;
  uchar *spot = data_ + ((y*width_)+x)*3;
  a = *spot++;
  a |= ((uint) *spot++) << 8;
  a |= ((uint) *spot) << 16;
  
  return a;
}

inline void 
RGBBuffer::set_pixel ( uint x, uint y, uint pixel )
{
  uchar *spot = data_ + ((y*width_)+x)*3;
  *spot++ = pixel & 0x000000ff;
  *spot++ = pixel & 0x0000ff00 >> 8;
  *spot   = pixel & 0x00ff0000 >> 16;
}

#endif
