#ifndef SPHERE
#define SPHERE

#include "object.hh"

class Sphere : public Object
{
public:
  Sphere ();
  Sphere ( const Vector& c, double r );
  virtual ~Sphere ();
  
  void set_center ( const Vector& c ) { center = c; }
  const Vector& get_center ()         { return center; }
  void set_radius ( double r )        { radius = r; }
  double get_radius ()                { return radius; }

  virtual bool inside () const;

protected:
  virtual Vector normal () const;
  virtual Vector _intersection ( const Line& line ) const;

private:
  Vector center;
  double radius;
  Vector *norm;
  bool *ins;
};

#endif
