#ifndef SURFACE
#define SURFACE

#include "vector.hh"
#include "rgb.hh"

class Surface
{
public:
  Surface ();
  
  Vector normal;
  rgb color;
  double diffuse, specular, hardness, transparency, reflect, refract, ior;

  Surface& operator += ( const Surface& rhs );
  Surface& operator *= ( const Surface& rhs );
  Surface& operator *= ( double rhs );

protected:

private:
  Surface ( int dummy ) {} // no initialization.
  
  friend Surface operator+ ( const Surface&, const Surface& );
  friend Surface operator* ( const Surface&, const Surface& );
  friend Surface operator* ( const Surface&, double );
};

Surface operator+ ( const Surface& a, const Surface& b );
Surface operator* ( const Surface& a, const Surface& b );
Surface operator* ( const Surface& a, double b );

#endif
