/*
 * Project : "MindsEye"
 * Copyright (c) 1997. All Rights Reserved.
 * Atuhor(s): M. Kuball
 *
 * $Id: insert_op.h,v 1.2 2001/02/10 18:11:47 ainvar Exp $
 *
 *
 * COPYRIGHT
 * ========= 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 * OVERVIEW
 * ========
 *
 */

#ifndef _SCENE_ITERATOR_H
#define _SCENE_ITERATOR_H

#include "3dlib/t_objects.h"
#include "3dlib/object.h"
#include "3dlib/g_operator.h"

extern void trace ( G3DGroup *group, MeViewItem* );


/**Parse the Scene Graph and construct the tree list with respect
   to the shapes and groups.
 */
class InsertOp : public G3D_Operator
{
public:
  InsertOp ( MeViewItem *start ) { start_ = start; };
  
  virtual bool exec ( G3DObject *obj ) {
    MeViewItem *tmp = new MeViewItem( start_, obj );
    if (IS_SUBTYPE(obj->getType(), T_GROUP))
      trace ((G3DGroup*)obj, tmp);
    return false;
  }
  
private:
  QListViewItem *start_;
};



#endif

