/*
 * Project : "MindsEye"
 * Copyright (d) 1996, 1997. All Rights Reserved.
 * Author(s): M. van Velsen, M. Kuball
 *
 * $Id: viewitem.h,v 1.2 2001/02/10 18:11:47 ainvar Exp $
 * 
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * OVERVIEW
 * ========
 *
 *
 */


#ifndef __DATA_TREE_H
#define __DATA_TREE_H

#include <qlistview.h>


//>------ define node types
#define NODE_CHILD        0
#define NODE_NEXT         1

//>------ size defines
#define NODE_WIDTH       33
#define NODE_OFFSET      22
#define NODE_HEIGHT      15

#define X_BORDER          5
#define Y_BORDER          5

#define Y_DISTANCE        5

//>------ defines if the node should display all that lies beneath
#define NODE_CONTRACTED   0
#define NODE_EXPANDED     1

//>------ will be removed later
//#define TRUE              0
//#define FALSE             1

#define ND_PLUS           0
#define ND_MIN            1
#define ND_NUL            2 

//>------ node types

#define NODE_CAMERA       3
#define NODE_LIGHT        4
#define NODE_OBJECT       5  // mesh
#define NODE_OBJECT_PRIM  6  // primitive
#define NODE_SCENE        7
#define NODE_PATH         8  
#define NODE_SOUND        9
#define NODE_ANIM        10 
#define NODE_MUSIC       11
#define NODE_MATERIAL    12

class G3DObject;
class MWorldObject;

/**Virtual base Class for the tree list items used in MindsEye.
  Te class is used to define a common protocol for all items.
  */
class MeViewItem : public QListViewItem
{
public:
  MeViewItem ( QListViewItem*, G3DObject* );
  MeViewItem ( QListViewItem*, const char* );
  ///construct the root item
  MeViewItem ( QListView*, G3DObject* );
  ~MeViewItem ();

  G3DObject* getObject () { return object_; }
  void       remove ( MWorldObject* );
  void       select ( MWorldObject* );
  //void       selectOff ( MWorldObject* );
  //void       selectOn ( MWorldObject* );
  void       update ();

protected:
  virtual void activate ();

  G3DObject  *object_;
};


#endif 
