/*
 * Project : "MindsEye"
 * Copyright (c) 1996, 1997 by Martin Kuball. All Rights Reserved.
 * Author(s): M. Kuball, M. van Velsen, F. Meier
 * 
 * $Id: controler.h,v 1.3 2002/06/16 20:50:39 ainvar Exp $
 *
 *
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * OVERVIEW
 * ========
 *
 */

#ifndef _CONTROLER_H_
#define _CONTROLER_H_

#include "include/config.h"
//#include "include/config.h"
#include <qobject.h>
//#include <qevent.h>
#include "3dlib/g3d_math.h"

class G3DCamera;
class QCursor;
class QEvent;


/**Abstract base class for Controler which are used to translate user
   input into manipulation of objects or cameras.
  */
class MEControler : public QObject
{
  Q_OBJECT

public:
  MEControler () : QObject(NULL, NULL) { camera_ = NULL; }
  virtual ~MEControler( );

  void setCamera( G3DCamera* );

    ///Set transformation values directly, without using the mouse.
  virtual void evaluate(  G3DVector3d& );
  virtual void evaluateInput( QMouseEvent*, int ) = 0;
  virtual QCursor* getCursor ();
  virtual void showFeedback ();
  virtual void start( QMouseEvent* ) = 0;
  virtual void stop () = 0;

    ///Set transformation values directly, without using the mouse.
  //virtual void transform(  G3DVector3d& );

signals:
  void setInfoText (const QString&);

protected:
  G3DCamera   *camera_;
  G3DVector3d direction_;

};


#endif
