/*
 * Project : "MindsEye"
 * Copyright 1996 - 1997. All Rights Reserved.
 * Author(s) M. van Velsen, M. Kuball
 *
 * $Id: m_viewm.cpp,v 1.2 2000/02/11 22:41:11 ainvar Exp $
 * 
 * 
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 * OVERVIEW
 * ========
 *
 *
 */

#include "include/config.h"
#include <qlabel.h>
#include <qlined.h>
#include <qpixmap.h>

#include "modeler/modeler.h"
#include "m_viewm.h"
#include "m_vdef.h"


MEStatusBar::MEStatusBar (QWidget *parent) :
  QFrame(parent)
{
  setMinimumSize (200, BUTTON_HEIGHT + 2);

  coordinateText_[0] = '\0';
  showAnimationTool_ = false;
  
  //>------- mouse coordinates
  coorLabel_ = new QLabel (this);
  coorLabel_->setFrameStyle (QFrame::WinPanel | QFrame::Sunken);
  //coorLabel_->setBackgroundColor (darkGray);
  coorLabel_->setAlignment (AlignLeft | AlignVCenter);
  coorLabel_->setGeometry (1, 1, 200, BUTTON_HEIGHT);
  coorLabel_->setText (coordinateText_);
  
  infoField_ = new QLabel (this);
  infoField_->setFrameStyle (QFrame::WinPanel | QFrame::Sunken);
  //infoField_->setBackgroundColor (darkGray);
  infoField_->setAlignment (AlignLeft | AlignVCenter);
  infoField_->move (201, 1); 
}

MEStatusBar::~MEStatusBar (void)
{
}


void
MEStatusBar::resizeEvent (QResizeEvent *)
{
  int w = width() - 200;
  if( showAnimationTool_ )
    {
      w -= animationTool_->width();
      animationTool_->move( 201 + w, 0 );
    }
  infoField_->resize( w, BUTTON_HEIGHT );
}

void
MEStatusBar::setCoordinateText (const QString& text)
{
  strncpy (coordinateText_, text.ascii(), 60);
  coordinateText_[59] = '\0';
  coorLabel_->setText (coordinateText_);
}

void
MEStatusBar::setInfoText (const QString& text)
{
  infoField_->setText(text.ascii());
}

void
MEStatusBar::toggleAnimationWidget (bool b)
{
  showAnimationTool_ = b;
  resizeEvent (0);
}


/* TODO move to toolbar
void MEStatusBar::toggle_axes (bool on)
{
  viewLayout_->toggle_axes (on); 
}

void MEStatusBar::toggle_grid (bool on)
{
  viewLayout_->toggle_grid (on); 
}
*/

//==================================END======================================
