/*
 * Project : "MindsEye"
 * Copyright 1996. All Rights Reserved.
 * Author(s) M. van Velsen, M. Kuball
 *
 * $Id: m_viewm.h,v 1.2 2000/02/11 22:41:11 ainvar Exp $
 *
 * 
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 * OVERVIEW
 * ========
 *
 *
 */
 
#ifndef __STATUS_BAR_H__
#define __STATUS_BAR_H__

#include <qframe.h>


#define BUTTON_HEIGHT 20


class QLabel;
class MEAnimationWidget;


/**A widget which manages the view ports.
 */
class MEStatusBar : public QFrame
{
  Q_OBJECT

public:
  ///
  MEStatusBar (QWidget *parent=0);
  virtual ~MEStatusBar ();

  void addAnimationWidget (QWidget *aw) { animationTool_ = aw; }
  void toggleAnimationWidget (bool);
  void setInfoText (const QString&);
  
public slots:
  ///
  void setCoordinateText (const QString&);

protected:

  void resizeEvent (QResizeEvent*);

private:

  QLabel  *coorLabel_;
  QLabel  *infoField_;
  QWidget *animationTool_;
  bool     showAnimationTool_;

  char coordinateText_[60];
};

#endif // __MVIEWPORT_M_H__
