/*
 * vi:ts=4:sw=4:
 *
 * Project : "MindsEye"
 * Copyright 1996. All Rights Reserved.
 * Author(s) M. van Velsen, M. Kuball
 *
 * $Id: m_vmenu.h,v 1.1.1.1 1999/09/10 00:00:07 iamcliff Exp $
 * 
 * 
 * COPYRIGHT
 * =========
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 * OVERVIEW
 * ========
 *
 */

#ifndef __MV_MENU_H__
#define __MV_MENU_H__


#include <qpopmenu.h>

class G3DObject;


/**This popup menu is shown when the user requests a popup in an MGLPort
  and an object is selected.*/
class MObjectPopup : public QPopupMenu
{

  Q_OBJECT
	
public:
  MObjectPopup( G3DObject*, QWidget* );

};


/**This popup menu is shown when the user requests a popup in an MGLPort
  and no object is selected.*/
class MViewportPopup : public QPopupMenu
{

  Q_OBJECT
	
public:
  MViewportPopup( QWidget* );

signals:        
  void setShadingMode(int);
  void changeCameraType(int);
  void redraw_viewport();
    ///
  void centerCamera();

protected slots:
  void center();
  void redraw ();
  void setParallel(int);
  void setPerspective();
  void setShading(int);

private:
  QPopupMenu *shadingPopup;
  QPopupMenu *viewport_popup;

};


#endif
